Program Nerowb60;

Uses dos,sysutils{$ifdef CREATELOG},log{$endif};

procedure send(const amessage: string; const aflush: boolean = true);
var
  (*
  llist: tstringlist;
  *)
  i: integer;
begin
  writeln(output, amessage);
  if aflush then
    flush(output);
  {$ifdef CREATELOG}
  if pos(lineending, amessage) = 0 then
    log.append(concat('<- ', amessage))
  else
  begin
    (*
    llist := tstringlist.create;
    llist.text := amessage;
    for i := 0 to pred(llist.count) do
      log.append(concat('<- ', llist[i]));
    llist.free;
    *)
  end;
  {$endif}
end;

const blines=250;
      maxdepth=26;
      maxmoves=150;
      files=8;
      ranks=8;
      noldpos=52;

type bltype=^string;
positiontype = array [1..files,1..ranks] of shortint;

         movetype = record
           file1,rank1,file2,rank2,degree:shortint;
         end;

VAR        postaa,forcing,whitesturn,playeriswhite:boolean;
         perakk,lnopr,siirrot,lisa,material,fixeddepth,aa,cee,joku:integer;
                     muisti,nerotime,aika,movesecs:longint;
                            komento,templine,avaus:string;
                     bookline:array [1..blines] of bltype;


      position  :  positiontype;

         legals      :  array [1..maxdepth+1] of integer;
         beta,curr   :  array [1..maxdepth+1] of integer;
         enpassant   :  array [1..maxdepth+1] of shortint;
         legmvs      :  array [1..maxdepth+1,1..maxmoves] of movetype;
         movescores  :  array [1..maxmoves] of integer;
         killer,killer2      :  array [2..maxdepth+1] of movetype;
         killval     :  array [2..maxdepth+1] of integer;
         oldpos,oldopp      :  array [1..noldpos] of string;
         isoin       :  array [1..maxdepth+1] of integer;


         k3,k1,bigs,storesc,searchdepth,mcount,rrate,hyva,huonoja,huonoja2,
      b3val,ruutu,viimeksi,wmat,bmat,bonus,ekstra,movesmade,posvalue:integer;
                         kpos,positions,pos2:longint;
      mwk,mbk,mwra,mbra,mwrh,mbrh,viewscores,analysis,musta,
                   plus1,keskeyta,opening,stopcalc:boolean;
                   best3,b3,b2,nextmove:movetype;

 replystr,kpstr,beststr,lstr,destr,cstr,mstr,thispos:string;
                             wkx,wky,bkx,bky:shortint;
                                         chi:char;
             ho2,mi2,se2,hu2,ho1,mi1,se1,hu1:word;
                               sekunnit,smax:longint;


{********************************************************************}

PROCEDURE searchlegmvs(forwhite:boolean;depth:integer);
Var x1,y1,moved,taken:shortint;ep,nopossiblechecks,incheck:boolean;

procedure makemove(x2,y2:shortint);

Begin
  moved:=position[x1,y1];
  taken:=position[x2,y2];
  position[x1,y1]:=0;
  position[x2,y2]:=moved;
  if (ep) then position[x2,y1]:=0;

  if (moved>0) then begin
    if (moved=1) then begin
      wkx:=x2;wky:=y2;
      if (x2=x1+2) then begin
        position[8,1]:=0;position[6,1]:=3
      end
      else if (x2=x1-2) then begin
        position[1,1]:=0;position[4,1]:=3
      end
    end
    else if ((moved=6) and (y2=ranks)) then position[x2,y2]:=2
  end
  else begin
    if (moved=-1) then begin
      bkx:=x2;bky:=y2;
      if (x2=x1+2) then begin
        position[8,8]:=0;position[6,8]:=-3
      end
      else if (x2=x1-2) then begin
        position[1,8]:=0;position[4,8]:=-3
      end
    end
    else if ((moved=-6) and (y2=1)) then position[x2,y2]:=-2
  end
end;

procedure unmakemv(x2,y2:shortint);
Begin
  position[x1,y1]:=moved;
  position[x2,y2]:=taken;

  if (moved>0) then begin
    if (ep) then position[x2,y1]:=-6
    else if (moved=1) then begin
      wkx:=x1;wky:=y1;
      if (x2=x1+2) then begin
        position[8,1]:=3;position[6,1]:=0
      end
      else if (x2=x1-2) then begin
        position[1,1]:=3;position[4,1]:=0
      end
    end
  end
  else begin
    if (ep) then position[x2,y1]:=6
    else if (moved=-1) then begin
      bkx:=x1;bky:=y1;
      if (x2=x1+2) then begin
        position[8,8]:=-3;position[6,8]:=0
      end
      else if (x2=x1-2) then begin
        position[1,8]:=-3;position[4,8]:=0
      end
    end
  end
End;

function kingincheck:boolean;
var xx,yy:shortint;
label 111,222;
begin
  kingincheck:=false;
  if (forwhite) then begin
    if ((wkx>1) and (wky>1)) then
      if (position[wkx-1,wky-1]=-1) then goto 111;
    if (wkx>1) then
      if (position[wkx-1,wky]=-1) then goto 111;
    if (wkx<files) then
      if (position[wkx+1,wky]=-1) then goto 111;
    if (wky>1) then
      if (position[wkx,wky-1]=-1) then goto 111;
    if (wky<ranks) then
      if (position[wkx,wky+1]=-1) then goto 111;
    if ((wkx<files) and (wky<ranks)) then begin
      if (position[wkx+1,wky+1]=-6) then goto 111;
      if (position[wkx+1,wky+1]=-1) then goto 111
    end;
    if ((wkx<files) and (wky>1)) then
      if (position[wkx+1,wky-1]=-1) then goto 111;
    if ((wkx>1) and (wky<ranks)) then begin
      if (position[wkx-1,wky+1]=-6) then goto 111;
      if (position[wkx-1,wky+1]=-1) then goto 111
    end;
  if ((wkx>2) and (wky<ranks)) then
    if (position[wkx-2,wky+1]=-5) then goto 111;
  if ((wkx>2) and (wky>1)) then
    if (position[wkx-2,wky-1]=-5) then goto 111;
  if ((wkx<files-1) and (wky<ranks)) then
    if (position[wkx+2,wky+1]=-5) then goto 111;
  if ((wkx<files-1) and (wky>1)) then
    if (position[wkx+2,wky-1]=-5) then goto 111;
  if ((wkx<files) and (wky>2)) then
    if (position[wkx+1,wky-2]=-5) then goto 111;
  if ((wkx>1) and (wky>2)) then
    if (position[wkx-1,wky-2]=-5) then goto 111;
  if ((wkx<files) and (wky<ranks-1)) then
    if (position[wkx+1,wky+2]=-5) then goto 111;
  if ((wkx>1) and (wky<ranks-1)) then
    if (position[wkx-1,wky+2]=-5) then goto 111;
  xx:=wkx;yy:=wky;
  repeat
    if (yy<ranks) then if (position[xx,yy+1]=0) then yy:=yy+1;
  until ((yy=ranks) or (position[xx,yy+1]<>0));
  if (yy<ranks) then
  if ((position[xx,yy+1]=-2) or (position[xx,yy+1]=-3)) then goto 111;
  xx:=wkx;yy:=wky;
  repeat
    if (yy>1) then if (position[xx,yy-1]=0) then yy:=yy-1;
  until ((yy=1) or (position[xx,yy-1]<>0));

  if (yy>1) then
  if ((position[xx,yy-1]=-2) or (position[xx,yy-1]=-3)) then goto 111;
  xx:=wkx;yy:=wky;
  repeat
    if (xx<files) then if (position[xx+1,yy]=0) then xx:=xx+1;
  until ((xx=files) or (position[xx+1,yy]<>0));
  if (xx<files) then
  if ((position[xx+1,yy]=-2) or (position[xx+1,yy]=-3)) then goto 111;
  xx:=wkx;yy:=wky;
  repeat
    if (xx>1) then if (position[xx-1,yy]=0) then xx:=xx-1;
  until ((xx=1) or (position[xx-1,yy]<>0));
  if (xx>1) then
  if ((position[xx-1,yy]=-2) or (position[xx-1,yy]=-3)) then goto 111;

  xx:=wkx;yy:=wky;
  repeat
    if ((xx>1) and (yy>1)) then if (position[xx-1,yy-1]=0) then begin
     xx:=xx-1;yy:=yy-1;
    end;
  until ((xx=1) or (yy=1) or (position[xx-1,yy-1]<>0));
  if ((xx>1) and (yy>1)) then
  if ((position[xx-1,yy-1]=-2) or (position[xx-1,yy-1]=-4)) then goto 111;
  xx:=wkx;yy:=wky;
  repeat
    if ((xx>1) and (yy<ranks)) then if (position[xx-1,yy+1]=0) then begin
     xx:=xx-1;yy:=yy+1;
    end;
  until ((xx=1) or (yy=ranks) or (position[xx-1,yy+1]<>0));
  if ((xx>1) and (yy<ranks)) then
  if ((position[xx-1,yy+1]=-2) or (position[xx-1,yy+1]=-4)) then goto 111;
  xx:=wkx;yy:=wky;
  repeat
    if ((xx<files) and (yy>1)) then if (position[xx+1,yy-1]=0) then begin
     xx:=xx+1;yy:=yy-1;
    end;
  until ((xx=files) or (yy=1) or (position[xx+1,yy-1]<>0));
  if ((xx<files) and (yy>1)) then
  if ((position[xx+1,yy-1]=-2) or (position[xx+1,yy-1]=-4)) then goto 111;
  xx:=wkx;yy:=wky;
  repeat
    if ((xx<files) and (yy<ranks)) then if (position[xx+1,yy+1]=0) then
    begin
     xx:=xx+1;yy:=yy+1;
    end;
  until ((xx=files) or (yy=ranks) or (position[xx+1,yy+1]<>0));
  if ((xx<files) and (yy<ranks)) then
  if ((position[xx+1,yy+1]=-2) or (position[xx+1,yy+1]=-4)) then goto 111;
  end
  else begin
    if ((bkx>1) and (bky>1)) then begin
      if (position[bkx-1,bky-1]=1) then goto 111;
      if (position[bkx-1,bky-1]=6) then goto 111;
    end;
    if (bkx>1) then
      if (position[bkx-1,bky]=1) then goto 111;
    if (bkx<files) then
      if (position[bkx+1,bky]=1) then goto 111;
    if (bky>1) then
      if (position[bkx,bky-1]=1) then goto 111;
    if (bky<ranks) then
      if (position[bkx,bky+1]=1) then goto 111;
    if ((bkx<files) and (bky<ranks)) then
      if (position[bkx+1,bky+1]=1) then goto 111;
    if ((bkx<files) and (bky>1)) then begin
      if (position[bkx+1,bky-1]=1) then goto 111;
      if (position[bkx+1,bky-1]=6) then goto 111;
    end;
    if ((bkx>1) and (bky<ranks)) then
      if (position[bkx-1,bky+1]=1) then goto 111;
  if ((bkx>2) and (bky<ranks)) then
    if (position[bkx-2,bky+1]=5) then goto 111;
  if ((bkx>2) and (bky>1)) then
    if (position[bkx-2,bky-1]=5) then goto 111;
  if ((bkx<files-1) and (bky<ranks)) then
    if (position[bkx+2,bky+1]=5) then goto 111;
  if ((bkx<files-1) and (bky>1)) then
    if (position[bkx+2,bky-1]=5) then goto 111;
  if ((bkx<files) and (bky>2)) then
    if (position[bkx+1,bky-2]=5) then goto 111;
  if ((bkx>1) and (bky>2)) then
    if (position[bkx-1,bky-2]=5) then goto 111;
  if ((bkx<files) and (bky<ranks-1)) then
    if (position[bkx+1,bky+2]=5) then goto 111;
  if ((bkx>1) and (bky<ranks-1)) then
    if (position[bkx-1,bky+2]=5) then goto 111;
  xx:=bkx;yy:=bky;
  repeat
    if (yy<ranks) then if (position[xx,yy+1]=0) then yy:=yy+1;
  until ((yy=ranks) or (position[xx,yy+1]<>0));
  if (yy<ranks) then
  if ((position[xx,yy+1]=2) or (position[xx,yy+1]=3)) then goto 111;
  xx:=bkx;yy:=bky;
  repeat
    if (yy>1) then if (position[xx,yy-1]=0) then yy:=yy-1;
  until ((yy=1) or (position[xx,yy-1]<>0));
  if (yy>1) then
  if ((position[xx,yy-1]=2) or (position[xx,yy-1]=3)) then goto 111;
  xx:=bkx;yy:=bky;
  repeat
    if (xx<files) then if (position[xx+1,yy]=0) then xx:=xx+1;
  until ((xx=files) or (position[xx+1,yy]<>0));
  if (xx<files) then
  if ((position[xx+1,yy]=2) or (position[xx+1,yy]=3)) then goto 111;
  xx:=bkx;yy:=bky;
  repeat
    if (xx>1) then if (position[xx-1,yy]=0) then xx:=xx-1;
  until ((xx=1) or (position[xx-1,yy]<>0));
  if (xx>1) then
  if ((position[xx-1,yy]=2) or (position[xx-1,yy]=3)) then goto 111;
  xx:=bkx;yy:=bky;
  repeat
    if ((xx>1) and (yy>1)) then if (position[xx-1,yy-1]=0) then begin
     xx:=xx-1;yy:=yy-1;
    end;
  until ((xx=1) or (yy=1) or (position[xx-1,yy-1]<>0));
  if ((xx>1) and (yy>1)) then
  if ((position[xx-1,yy-1]=2) or (position[xx-1,yy-1]=4)) then goto 111;
  xx:=bkx;yy:=bky;
  repeat
    if ((xx>1) and (yy<ranks)) then if (position[xx-1,yy+1]=0) then begin
     xx:=xx-1;yy:=yy+1;
    end;
  until ((xx=1) or (yy=ranks) or (position[xx-1,yy+1]<>0));
  if ((xx>1) and (yy<ranks)) then
  if ((position[xx-1,yy+1]=2) or (position[xx-1,yy+1]=4)) then goto 111;
  xx:=bkx;yy:=bky;
  repeat
    if ((xx<files) and (yy>1)) then if (position[xx+1,yy-1]=0) then begin
     xx:=xx+1;yy:=yy-1;
    end;
  until ((xx=files) or (yy=1) or (position[xx+1,yy-1]<>0));
  if ((xx<files) and (yy>1)) then
  if ((position[xx+1,yy-1]=2) or (position[xx+1,yy-1]=4)) then goto 111;
  xx:=bkx;yy:=bky;
  repeat
    if ((xx<files) and (yy<ranks)) then if (position[xx+1,yy+1]=0) then
    begin
     xx:=xx+1;yy:=yy+1;
    end;
  until ((xx=files) or (yy=ranks) or (position[xx+1,yy+1]<>0));
  if ((xx<files) and (yy<ranks)) then
  if ((position[xx+1,yy+1]=2) or (position[xx+1,yy+1]=4)) then goto 111;
  end;
  goto 222;
111:kingincheck:=true;
222:
end;

procedure checkleg(x2,y2:shortint);
var islegal:boolean;
begin
  makemove(x2,y2);
  islegal:=((nopossiblechecks) and (abs(moved)>1));
  if (not islegal) then islegal:=(not kingincheck);
  if (islegal) then begin
    if (legals[depth]<maxmoves) then begin
      legals[depth]:=legals[depth]+1;
      legmvs[depth,legals[depth]].file1:=x1;
      legmvs[depth,legals[depth]].rank1:=y1;
      legmvs[depth,legals[depth]].file2:=x2;
      legmvs[depth,legals[depth]].rank2:=y2;
      if (taken=0) then legmvs[depth,legals[depth]].degree:=3
      else if (abs(taken)<6) then legmvs[depth,legals[depth]].degree:=1
      else legmvs[depth,legals[depth]].degree:=2;

      if (ep) then legmvs[depth,legals[depth]].degree:=2;
      if ((moved=6) and (y2=ranks))
      then legmvs[depth,legals[depth]].degree:=1;
      if ((moved=-6) and (y2=1))
      then legmvs[depth,legals[depth]].degree:=1;
    end;
  end;
  unmakemv(x2,y2)
end;

procedure blackknight;
begin
  if ((x1<files) and (y1<ranks-1) and (position[x1+1,y1+2]>-1))
    then checkleg(x1+1,y1+2);
  if ((x1<files) and (y1>2) and (position[x1+1,y1-2]>-1))
    then checkleg(x1+1,y1-2);
  if ((x1>1) and (y1<ranks-1) and (position[x1-1,y1+2]>-1))
    then checkleg(x1-1,y1+2);
  if ((x1>1) and (y1>2) and (position[x1-1,y1-2]>-1))
    then checkleg(x1-1,y1-2);
  if ((x1<files-1) and (y1<ranks) and (position[x1+2,y1+1]>-1))
    then checkleg(x1+2,y1+1);
  if ((x1<files-1) and (y1>1) and (position[x1+2,y1-1]>-1))
    then checkleg(x1+2,y1-1);
  if ((x1>2) and (y1<ranks) and (position[x1-2,y1+1]>-1))
    then checkleg(x1-2,y1+1);
  if ((x1>2) and (y1>1) and (position[x1-2,y1-1]>-1))
    then checkleg(x1-2,y1-1);
end;

procedure blackking;
var nhelp:integer;
begin
  if ((x1<files) and (y1<ranks) and (position[x1+1,y1+1]>-1))
    then checkleg(x1+1,y1+1);
  if ((x1<files) and (y1>1) and (position[x1+1,y1-1]>-1))
    then checkleg(x1+1,y1-1);
  if ((x1>1) and (y1<ranks) and (position[x1-1,y1+1]>-1))
    then checkleg(x1-1,y1+1);
  if ((x1>1) and (y1>1) and (position[x1-1,y1-1]>-1))
    then checkleg(x1-1,y1-1);
  nhelp:=legals[depth];
  if ((x1<files) and (position[x1+1,y1]>-1))
    then checkleg(x1+1,y1);
  if ((x1=5) and (y1=8) and (legals[depth]>nhelp)) then begin
    if ((not mbk) and (not mbrh) and (position[6,8]=0)
    and (position[8,8]=-3) and
    (position[7,8]=0) and (not kingincheck)) then checkleg(x1+2,y1)
  end;
  if ((y1>1) and (position[x1,y1-1]>-1))
    then checkleg(x1,y1-1);
  if ((y1<ranks) and (position[x1,y1+1]>-1))
    then checkleg(x1,y1+1);
  nhelp:=legals[depth];
  if ((x1>1) and (position[x1-1,y1]>-1))
    then checkleg(x1-1,y1);
  if ((x1=5) and (y1=8) and (legals[depth]>nhelp)) then begin
    if ((not mbk) and (not mbra) and (position[4,8]=0) and (position[2,8]=0)
    and (position[1,8]=-3)
    and (position[3,8]=0) and (not kingincheck)) then checkleg(x1-2,y1)
  end;
end;

procedure whiteking;
var nhelp:integer;
begin
  if ((x1<files) and (y1<ranks) and (position[x1+1,y1+1]<1))
    then checkleg(x1+1,y1+1);
  if ((x1<files) and (y1>1) and (position[x1+1,y1-1]<1))
    then checkleg(x1+1,y1-1);
  if ((x1>1) and (y1<ranks) and (position[x1-1,y1+1]<1))
    then checkleg(x1-1,y1+1);
  if ((x1>1) and (y1>1) and (position[x1-1,y1-1]<1))
    then checkleg(x1-1,y1-1);
  nhelp:=legals[depth];
  if ((x1<files) and (position[x1+1,y1]<1))
    then checkleg(x1+1,y1);
  if ((x1=5) and (y1=1) and (legals[depth]>nhelp)) then begin
    if ((not mwk) and (not mwrh) and (position[6,1]=0)
    and (position[8,1]=3) and
    (position[7,1]=0) and (not kingincheck)) then checkleg(x1+2,y1)
  end;
  if ((y1>1) and (position[x1,y1-1]<1))
    then checkleg(x1,y1-1);
  if ((y1<ranks) and (position[x1,y1+1]<1))
    then checkleg(x1,y1+1);
  nhelp:=legals[depth];
  if ((x1>1) and (position[x1-1,y1]<1))
    then checkleg(x1-1,y1);
  if ((x1=5) and (y1=1) and (legals[depth]>nhelp)) then begin
    if ((not mwk) and (not mwra) and (position[4,1]=0)
    and (position[1,1]=3) and (position[3,1]=0)
    and (position[2,1]=0) and (not kingincheck)) then checkleg(x1-2,y1)
  end;
end;

procedure whitepawn;
begin
  if ((x1<files) and (y1<ranks) and (position[x1+1,y1+1]<0))
    then checkleg(x1+1,y1+1);
  if ((x1>1) and (y1<ranks) and (position[x1-1,y1+1]<0))
    then checkleg(x1-1,y1+1);
  if ((y1<ranks) and (position[x1,y1+1]=0))
    then checkleg(x1,y1+1);
  if ((y1=2) and (position[x1,3]=0) and (position[x1,4]=0))
    then checkleg(x1,4);
  if ((y1=5) and (enpassant[depth]=x1+1)) then begin
    ep:=true;
    checkleg(x1+1,6);
    ep:=false
  end;
  if ((y1=5) and (enpassant[depth]=x1-1)) then begin
    ep:=true;
    checkleg(x1-1,6);
    ep:=false
  end
end;

procedure blackpawn;
begin
  if ((x1<files) and (y1>1) and (position[x1+1,y1-1]>0))
    then checkleg(x1+1,y1-1);
  if ((x1>1) and (y1>1) and (position[x1-1,y1-1]>0))
    then checkleg(x1-1,y1-1);
  if ((y1>1) and (position[x1,y1-1]=0))
    then checkleg(x1,y1-1);
  if ((y1=7) and (position[x1,6]=0) and (position[x1,5]=0))
    then checkleg(x1,5);
  if ((y1=4) and (enpassant[depth]=x1+1)) then begin
    ep:=true;
    checkleg(x1+1,3);
    ep:=false;
  end;
  if ((y1=4) and (enpassant[depth]=x1-1)) then begin
    ep:=true;
    checkleg(x1-1,3);
    ep:=false;
  end
end;

procedure whiteknight;
begin
  if ((x1<files) and (y1<ranks-1) and (position[x1+1,y1+2]<1))
    then checkleg(x1+1,y1+2);
  if ((x1<files) and (y1>2) and (position[x1+1,y1-2]<1))
    then checkleg(x1+1,y1-2);
  if ((x1>1) and (y1<ranks-1) and (position[x1-1,y1+2]<1))
    then checkleg(x1-1,y1+2);
  if ((x1>1) and (y1>2) and (position[x1-1,y1-2]<1))
    then checkleg(x1-1,y1-2);
  if ((x1<files-1) and (y1<ranks) and (position[x1+2,y1+1]<1))
    then checkleg(x1+2,y1+1);
  if ((x1<files-1) and (y1>1) and (position[x1+2,y1-1]<1))
    then checkleg(x1+2,y1-1);
  if ((x1>2) and (y1<ranks) and (position[x1-2,y1+1]<1))
    then checkleg(x1-2,y1+1);
  if ((x1>2) and (y1>1) and (position[x1-2,y1-1]<1))
    then checkleg(x1-2,y1-1);
end;

procedure whitequeen;
var xx,yy:shortint;
begin
  xx:=x1;yy:=y1;
  repeat
    if (yy<ranks) then
     if (position[xx,yy+1]=0) then begin
       yy:=yy+1;
       checkleg(xx,yy);
     end;
  until ((yy=ranks) or (position[xx,yy+1]<>0));
  if ((yy<ranks) and (position[xx,yy+1]<0)) then checkleg(xx,yy+1);
  xx:=x1;yy:=y1;
  repeat
    if (yy>1) then
     if (position[xx,yy-1]=0) then begin
       yy:=yy-1;
       checkleg(xx,yy);
     end;
  until ((yy=1) or (position[xx,yy-1]<>0));
  if ((yy>1) and (position[xx,yy-1]<0)) then checkleg(xx,yy-1);
  xx:=x1;yy:=y1;
  repeat
    if (xx<files) then
     if (position[xx+1,yy]=0) then begin
       xx:=xx+1;
       checkleg(xx,yy);
     end;
  until ((xx=files) or (position[xx+1,yy]<>0));
  if ((xx<files) and (position[xx+1,yy]<0)) then checkleg(xx+1,yy);
  xx:=x1;yy:=y1;
  repeat
    if (xx>1) then
     if (position[xx-1,yy]=0) then begin
       xx:=xx-1;
       checkleg(xx,yy);
     end;
  until ((xx=1) or (position[xx-1,yy]<>0));
  if ((xx>1) and (position[xx-1,yy]<0)) then checkleg(xx-1,yy);
  xx:=x1;yy:=y1;
  repeat
    if ((yy<ranks) and (xx<files)) then
     if (position[xx+1,yy+1]=0) then begin
       yy:=yy+1;xx:=xx+1;
       checkleg(xx,yy);
     end;
  until ((yy=ranks) or (xx=files) or (position[xx+1,yy+1]<>0));
  if ((yy<ranks) and (xx<files) and (position[xx+1,yy+1]<0))
  then checkleg(xx+1,yy+1);
  xx:=x1;yy:=y1;
  repeat
    if ((yy>1) and (xx<files)) then
     if (position[xx+1,yy-1]=0) then begin
       yy:=yy-1;xx:=xx+1;
       checkleg(xx,yy);
     end;
  until ((yy=1) or (xx=files) or (position[xx+1,yy-1]<>0));
  if ((yy>1) and (xx<files) and (position[xx+1,yy-1]<0))
  then checkleg(xx+1,yy-1);
  xx:=x1;yy:=y1;
  repeat
    if ((yy<ranks) and (xx>1)) then
     if (position[xx-1,yy+1]=0) then begin
       yy:=yy+1;xx:=xx-1;
       checkleg(xx,yy);
     end;
  until ((yy=ranks) or (xx=1) or (position[xx-1,yy+1]<>0));
  if ((yy<ranks) and (xx>1) and (position[xx-1,yy+1]<0))
  then checkleg(xx-1,yy+1);
  xx:=x1;yy:=y1;
  repeat
    if ((yy>1) and (xx>1)) then
     if (position[xx-1,yy-1]=0) then begin
       yy:=yy-1;xx:=xx-1;
       checkleg(xx,yy);
     end;
  until ((yy=1) or (xx=1) or (position[xx-1,yy-1]<>0));
  if ((yy>1) and (xx>1) and (position[xx-1,yy-1]<0))
  then checkleg(xx-1,yy-1);
end;

procedure blackqueen;
var xx,yy:shortint;
begin
  xx:=x1;yy:=y1;
  repeat
    if (yy<ranks) then
     if (position[xx,yy+1]=0) then begin
       yy:=yy+1;
       checkleg(xx,yy);
     end;
  until ((yy=ranks) or (position[xx,yy+1]<>0));
  if ((yy<ranks) and (position[xx,yy+1]>0)) then checkleg(xx,yy+1);
  xx:=x1;yy:=y1;
  repeat
    if (yy>1) then
     if (position[xx,yy-1]=0) then begin
       yy:=yy-1;
       checkleg(xx,yy);
     end;
  until ((yy=1) or (position[xx,yy-1]<>0));
  if ((yy>1) and (position[xx,yy-1]>0)) then checkleg(xx,yy-1);
  xx:=x1;yy:=y1;
  repeat
    if (xx<files) then
     if (position[xx+1,yy]=0) then begin
       xx:=xx+1;
       checkleg(xx,yy);
     end;
  until ((xx=files) or (position[xx+1,yy]<>0));
  if ((xx<files) and (position[xx+1,yy]>0)) then checkleg(xx+1,yy);
  xx:=x1;yy:=y1;
  repeat
    if (xx>1) then
     if (position[xx-1,yy]=0) then begin
       xx:=xx-1;
       checkleg(xx,yy);
     end;
  until ((xx=1) or (position[xx-1,yy]<>0));
  if ((xx>1) and (position[xx-1,yy]>0)) then checkleg(xx-1,yy);
  xx:=x1;yy:=y1;
  repeat
    if ((yy<ranks) and (xx<files)) then
     if (position[xx+1,yy+1]=0) then begin
       yy:=yy+1;xx:=xx+1;
       checkleg(xx,yy);
     end;
  until ((yy=ranks) or (xx=files) or (position[xx+1,yy+1]<>0));
  if ((yy<ranks) and (xx<files) and (position[xx+1,yy+1]>0))
  then checkleg(xx+1,yy+1);
  xx:=x1;yy:=y1;
  repeat
    if ((yy>1) and (xx<files)) then
     if (position[xx+1,yy-1]=0) then begin
       yy:=yy-1;xx:=xx+1;
       checkleg(xx,yy);
     end;
  until ((yy=1) or (xx=files) or (position[xx+1,yy-1]<>0));
  if ((yy>1) and (xx<files) and (position[xx+1,yy-1]>0))
  then checkleg(xx+1,yy-1);
  xx:=x1;yy:=y1;
  repeat
    if ((yy<ranks) and (xx>1)) then
     if (position[xx-1,yy+1]=0) then begin
       yy:=yy+1;xx:=xx-1;
       checkleg(xx,yy);
     end;
  until ((yy=ranks) or (xx=1) or (position[xx-1,yy+1]<>0));
  if ((yy<ranks) and (xx>1) and (position[xx-1,yy+1]>0))
  then checkleg(xx-1,yy+1);
  xx:=x1;yy:=y1;
  repeat
    if ((yy>1) and (xx>1)) then
     if (position[xx-1,yy-1]=0) then begin
       yy:=yy-1;xx:=xx-1;
       checkleg(xx,yy);
     end;
  until ((yy=1) or (xx=1) or (position[xx-1,yy-1]<>0));
  if ((yy>1) and (xx>1) and (position[xx-1,yy-1]>0))
  then checkleg(xx-1,yy-1);
end;

procedure whiterook;
var xx,yy:shortint;
begin
  xx:=x1;yy:=y1;
  repeat
    if (yy<ranks) then
     if (position[xx,yy+1]=0) then begin
       yy:=yy+1;
       checkleg(xx,yy);
     end;
  until ((yy=ranks) or (position[xx,yy+1]<>0));
  if ((yy<ranks) and (position[xx,yy+1]<0)) then checkleg(xx,yy+1);
  xx:=x1;yy:=y1;
  repeat
    if (yy>1) then
     if (position[xx,yy-1]=0) then begin
       yy:=yy-1;
       checkleg(xx,yy);
     end;
  until ((yy=1) or (position[xx,yy-1]<>0));
  if ((yy>1) and (position[xx,yy-1]<0)) then checkleg(xx,yy-1);
  xx:=x1;yy:=y1;
  repeat
    if (xx<files) then
     if (position[xx+1,yy]=0) then begin
       xx:=xx+1;
       checkleg(xx,yy);
     end;
  until ((xx=files) or (position[xx+1,yy]<>0));
  if ((xx<files) and (position[xx+1,yy]<0)) then checkleg(xx+1,yy);
  xx:=x1;yy:=y1;
  repeat
    if (xx>1) then
     if (position[xx-1,yy]=0) then begin
       xx:=xx-1;
       checkleg(xx,yy);
     end;
  until ((xx=1) or (position[xx-1,yy]<>0));
  if ((xx>1) and (position[xx-1,yy]<0)) then checkleg(xx-1,yy);
end;

procedure blackrook;
var xx,yy:shortint;
begin
  xx:=x1;yy:=y1;
  repeat
    if (yy<ranks) then
     if (position[xx,yy+1]=0) then begin
       yy:=yy+1;
       checkleg(xx,yy);
     end;
  until ((yy=ranks) or (position[xx,yy+1]<>0));
  if ((yy<ranks) and (position[xx,yy+1]>0)) then checkleg(xx,yy+1);
  xx:=x1;yy:=y1;
  repeat
    if (yy>1) then
     if (position[xx,yy-1]=0) then begin
       yy:=yy-1;
       checkleg(xx,yy);
     end;
  until ((yy=1) or (position[xx,yy-1]<>0));
  if ((yy>1) and (position[xx,yy-1]>0)) then checkleg(xx,yy-1);
  xx:=x1;yy:=y1;
  repeat
    if (xx<files) then
     if (position[xx+1,yy]=0) then begin
       xx:=xx+1;
       checkleg(xx,yy);
     end;
  until ((xx=files) or (position[xx+1,yy]<>0));
  if ((xx<files) and (position[xx+1,yy]>0)) then checkleg(xx+1,yy);
  xx:=x1;yy:=y1;
  repeat
    if (xx>1) then
     if (position[xx-1,yy]=0) then begin
       xx:=xx-1;
       checkleg(xx,yy);
     end;
  until ((xx=1) or (position[xx-1,yy]<>0));
  if ((xx>1) and (position[xx-1,yy]>0)) then checkleg(xx-1,yy);
end;

procedure whitebishop;
var xx,yy:shortint;
begin
  xx:=x1;yy:=y1;
  repeat
    if ((yy<ranks) and (xx<files)) then
     if (position[xx+1,yy+1]=0) then begin
       yy:=yy+1;xx:=xx+1;
       checkleg(xx,yy);
     end;
  until ((yy=ranks) or (xx=files) or (position[xx+1,yy+1]<>0));
  if ((yy<ranks) and (xx<files) and (position[xx+1,yy+1]<0))
  then checkleg(xx+1,yy+1);
  xx:=x1;yy:=y1;
  repeat
    if ((yy>1) and (xx<files)) then
     if (position[xx+1,yy-1]=0) then begin
       yy:=yy-1;xx:=xx+1;
       checkleg(xx,yy);
     end;
  until ((yy=1) or (xx=files) or (position[xx+1,yy-1]<>0));
  if ((yy>1) and (xx<files) and (position[xx+1,yy-1]<0))
  then checkleg(xx+1,yy-1);
  xx:=x1;yy:=y1;
  repeat
    if ((yy<ranks) and (xx>1)) then
     if (position[xx-1,yy+1]=0) then begin
       yy:=yy+1;xx:=xx-1;
       checkleg(xx,yy);
     end;
  until ((yy=ranks) or (xx=1) or (position[xx-1,yy+1]<>0));
  if ((yy<ranks) and (xx>1) and (position[xx-1,yy+1]<0))
  then checkleg(xx-1,yy+1);
  xx:=x1;yy:=y1;
  repeat
    if ((yy>1) and (xx>1)) then
     if (position[xx-1,yy-1]=0) then begin
       yy:=yy-1;xx:=xx-1;
       checkleg(xx,yy);
     end;
  until ((yy=1) or (xx=1) or (position[xx-1,yy-1]<>0));
  if ((yy>1) and (xx>1) and (position[xx-1,yy-1]<0))
  then checkleg(xx-1,yy-1);
end;

procedure blackbishop;
var xx,yy:shortint;
begin
  xx:=x1;yy:=y1;
  repeat
    if ((yy<ranks) and (xx<files)) then
     if (position[xx+1,yy+1]=0) then begin
       yy:=yy+1;xx:=xx+1;
       checkleg(xx,yy);
     end;
  until ((yy=ranks) or (xx=files) or (position[xx+1,yy+1]<>0));
  if ((yy<ranks) and (xx<files) and (position[xx+1,yy+1]>0))
  then checkleg(xx+1,yy+1);
  xx:=x1;yy:=y1;
  repeat
    if ((yy>1) and (xx<files)) then
     if (position[xx+1,yy-1]=0) then begin
       yy:=yy-1;xx:=xx+1;
       checkleg(xx,yy);
     end;
  until ((yy=1) or (xx=files) or (position[xx+1,yy-1]<>0));
  if ((yy>1) and (xx<files) and (position[xx+1,yy-1]>0))
  then checkleg(xx+1,yy-1);
  xx:=x1;yy:=y1;
  repeat
    if ((yy<ranks) and (xx>1)) then
     if (position[xx-1,yy+1]=0) then begin
       yy:=yy+1;xx:=xx-1;
       checkleg(xx,yy);
     end;
  until ((yy=ranks) or (xx=1) or (position[xx-1,yy+1]<>0));
  if ((yy<ranks) and (xx>1) and (position[xx-1,yy+1]>0))
  then checkleg(xx-1,yy+1);
  xx:=x1;yy:=y1;
  repeat
    if ((yy>1) and (xx>1)) then
     if (position[xx-1,yy-1]=0) then begin
       yy:=yy-1;xx:=xx-1;
       checkleg(xx,yy);
     end;
  until ((yy=1) or (xx=1) or (position[xx-1,yy-1]<>0));
  if ((yy>1) and (xx>1) and (position[xx-1,yy-1]>0))
  then checkleg(xx-1,yy-1);
end;

Begin
  ep:=false;
  legals[depth]:=0;incheck:=kingincheck;
  if (incheck) then nopossiblechecks:=false
  else begin
    nopossiblechecks:=true;
    if (forwhite) then begin
      for x1:=1 to 8 do if ((position[x1,wky]=-2) or
      (position[x1,wky]=-3)) then nopossiblechecks:=false;
      for x1:=1 to 8 do if ((position[wkx,x1]=-2) or
      (position[wkx,x1]=-3)) then nopossiblechecks:=false;
      x1:=wkx;y1:=wky;
      while ((x1<8) and (y1<8)) do begin
        x1:=x1+1;y1:=y1+1;
        if ((position[x1,y1]=-2) or
            (position[x1,y1]=-4)) then nopossiblechecks:=false;
      end;
      x1:=wkx;y1:=wky;
      while ((x1>1) and (y1<8)) do begin
        x1:=x1-1;y1:=y1+1;
        if ((position[x1,y1]=-2) or
            (position[x1,y1]=-4)) then nopossiblechecks:=false;
      end;
      x1:=wkx;y1:=wky;
      while ((x1<8) and (y1>1)) do begin
        x1:=x1+1;y1:=y1-1;
        if ((position[x1,y1]=-2) or
            (position[x1,y1]=-4)) then nopossiblechecks:=false;
      end;
      x1:=wkx;y1:=wky;
      while ((x1>1) and (y1>1)) do begin
        x1:=x1-1;y1:=y1-1;
        if ((position[x1,y1]=-2) or
            (position[x1,y1]=-4)) then nopossiblechecks:=false;
      end;
    end
    else begin
      for x1:=1 to 8 do if ((position[x1,bky]=2) or
      (position[x1,bky]=3)) then nopossiblechecks:=false;
      for x1:=1 to 8 do if ((position[bkx,x1]=2) or
      (position[bkx,x1]=3)) then nopossiblechecks:=false;
      x1:=bkx;y1:=bky;
      while ((x1<8) and (y1<8)) do begin
        x1:=x1+1;y1:=y1+1;
        if ((position[x1,y1]=2) or
            (position[x1,y1]=4)) then nopossiblechecks:=false;
      end;
      x1:=bkx;y1:=bky;
      while ((x1>1) and (y1<8)) do begin
        x1:=x1-1;y1:=y1+1;
        if ((position[x1,y1]=2) or
            (position[x1,y1]=4)) then nopossiblechecks:=false;
      end;
      x1:=bkx;y1:=bky;
      while ((x1<8) and (y1>1)) do begin
        x1:=x1+1;y1:=y1-1;
        if ((position[x1,y1]=2) or
            (position[x1,y1]=4)) then nopossiblechecks:=false;
      end;
      x1:=bkx;y1:=bky;
      while ((x1>1) and (y1>1)) do begin
        x1:=x1-1;y1:=y1-1;
        if ((position[x1,y1]=2) or
            (position[x1,y1]=4)) then nopossiblechecks:=false;
      end;
    end
  end;

  if (forwhite) then begin
    for y1:=ranks downto 1 do
    for x1:=1 to files do
         if (position[x1,y1]=5) then whiteknight
    else if (position[x1,y1]=6) then whitepawn
    else if (position[x1,y1]=1) then whiteking
    else if (position[x1,y1]=4) then whitebishop
    else if (position[x1,y1]=2) then whitequeen
    else if (position[x1,y1]=3) then whiterook
  end
  else begin
    for y1:=1 to ranks do
    for x1:=1 to files do
         if (position[x1,y1]=-5) then blackknight
    else if (position[x1,y1]=-6) then blackpawn
    else if (position[x1,y1]=-4) then blackbishop
    else if (position[x1,y1]=-2) then blackqueen
    else if (position[x1,y1]=-3) then blackrook
    else if (position[x1,y1]=-1) then blackking
  end;
  if (legals[depth]=0) then if (incheck) then legals[depth]:=-1
  else legals[depth]:=-2;
  if (legals[depth]>isoin[depth]) then isoin[depth]:=legals[depth];

    positions:=positions+1;
    if (positions>99) then begin
      positions:=0;kpos:=kpos+1;

      if (kpos mod 5=0) then begin
      gettime(ho2,mi2,se2,hu2);

      if (se2<se1) then se2:=se2+60;
      sekunnit:=sekunnit+100*se2-100*se1+hu2-hu1;

      gettime(ho1,mi1,se1,hu1);
      if ((sekunnit>=smax) and (searchdepth>1)) then keskeyta:=true

    end
    end;
End;
{*************************************************************************}
Function evaluate(forwhite:boolean;depth:integer):integer;
label 123;
Var ii,kk,jj,store,greatesteven,legeven,legodd,muisti,
     k,iii,kkk,a,b,movevalue,bestvalue:integer;
    moved,taken:shortint;helpmv:movetype;
    found,wq,bq,cutoff,notsafesqr:boolean;
Begin

  found:=false;
  if (forwhite) then bestvalue:=-30000 else
  bestvalue:=30000;

  muisti:=posvalue;
  {kaikki posvalue-muutokset muut kuin materiaali}
    for kk:=1 to depth-1 do begin
    ii:=legmvs[kk,curr[kk]].rank2-legmvs[kk,curr[kk]].rank1;
    posvalue:=posvalue+ii
    end;

    if (movesmade<20) then posvalue:=posvalue+random(27)-13+k1 else
    posvalue:=posvalue+k1;

    if (musta) then posvalue:=posvalue-k3 else posvalue:=posvalue+k3;

    kk:=0;legeven:=0;legodd:=0;
    if (depth mod 2=0) then greatesteven:=depth
    else greatesteven:=depth-1;
    repeat
      kk:=kk+1;
      if (kk mod 2=0) then legeven:=legeven+legals[kk]
      else legodd:=legodd+legals[kk]
    until kk=greatesteven;
    if (musta) then
    posvalue:=posvalue+((legeven-legodd) div (2*greatesteven))
    else posvalue:=posvalue-((legeven-legodd) div (2*greatesteven));

    if (wmat>2900) and (bmat>2900) then begin {avaus}
      if (wky>1) then posvalue:=posvalue-15;
      if (bky<8) then posvalue:=posvalue+15;
      if (wkx=5) then posvalue:=posvalue-15;
      if (bkx=5) then posvalue:=posvalue+15;
      if (wkx=4) then posvalue:=posvalue-15;
      if (bkx=4) then posvalue:=posvalue+15;
      if (wkx=6) then posvalue:=posvalue-15;
      if (bkx=6) then posvalue:=posvalue+15;
      {linnassa mokuja suojana? penalty ellei}
      if (wkx>6) and (wky=1) then begin
        if (position[8,2]<1) and (position[8,3]<1)
          then posvalue:=posvalue-40;
        if (position[7,2]<1) and (position[7,3]<1)
          then posvalue:=posvalue-40;
      end;
      if (bkx>6) and (bky=8) then begin
        if (position[8,7]>-1) and (position[8,6]>-1)
          then posvalue:=posvalue+40;
        if (position[7,7]>-1) and (position[7,6]>-1)
          then posvalue:=posvalue+40;
      end;

      if (position[4,1]<>2) and (movesmade<12) then posvalue:=posvalue-15;
      if (position[4,8]<>-2) and (movesmade<12) then posvalue:=posvalue+15;
      if (position[5,4]=6) then posvalue:=posvalue+25;
      if (position[5,2]=6) and (position[5,3]=4) then posvalue:=posvalue-40;
      if (position[4,2]=6) and (position[4,3]=4) then posvalue:=posvalue-40;
    if (position[5,7]=-6) and (position[5,6]=-4) then posvalue:=posvalue+40;
    if (position[4,7]=-6) and (position[4,6]=-4) then posvalue:=posvalue+40;
      if (position[4,4]=6) then posvalue:=posvalue+25;
      if (position[3,4]=4) then posvalue:=posvalue+10;
      if (position[2,2]=4) then posvalue:=posvalue+10;
      if (position[7,2]=4) then posvalue:=posvalue+7;
      if (position[6,4]=4) then posvalue:=posvalue+10;
      if (position[3,5]=-4) then posvalue:=posvalue-10;
      if (position[2,7]=-4) then posvalue:=posvalue-10;
      if (position[7,7]=-4) then posvalue:=posvalue-7;
      if (position[6,5]=-4) then posvalue:=posvalue-10;
      if (position[3,3]=5) then posvalue:=posvalue+7;
      if (position[6,3]=5) then posvalue:=posvalue+7;
      if (position[3,6]=-5) then posvalue:=posvalue-7;
      if (position[6,6]=-5) then posvalue:=posvalue-7;
      if (position[5,5]=-6) then posvalue:=posvalue-25;
      if (position[4,5]=-6) then posvalue:=posvalue-25;
        if (position[3,1]=4) then posvalue:=posvalue-20;
      if (position[6,1]=4) then posvalue:=posvalue-20;
      if (position[3,8]=-4) then posvalue:=posvalue+20;
      if (position[6,8]=-4) then posvalue:=posvalue+20;
    end; {avaus kohti keskustaa!}

      {loppupeli , kunu peliin!, kohti vast kunua}
      if (wmat<1600) and (bmat<1600) then begin {loppupeli}
        posvalue:=posvalue+abs(bkx-5)+abs(bky-5)-abs(wkx-5)-abs(wky-4);
        if (wmat=0) then posvalue:=posvalue-(abs(wkx-5)+abs(wky-4))*10;
        if (bmat=0) then posvalue:=posvalue+(abs(bkx-5)+abs(bky-4))*10;
      end;



      for kk:=1 to 8 do begin
      if (position[kk,1]=5) then posvalue:=posvalue-30;
      if (position[kk,2]=5) then posvalue:=posvalue-12;
      if (position[kk,8]=5) then posvalue:=posvalue-30;
      if (position[1,kk]=5) then posvalue:=posvalue-30;
      if (position[8,kk]=5) then posvalue:=posvalue-30;
      if (position[kk,1]=-5) then posvalue:=posvalue+30;
      if (position[kk,8]=-5) then posvalue:=posvalue+30;
      if (position[kk,7]=-5) then posvalue:=posvalue+12;
      if (position[1,kk]=-5) then posvalue:=posvalue+30;
      if (position[8,kk]=-5) then posvalue:=posvalue+30;
      end;

      for kk:=1 to 8 do begin
        if (position[kk,7]=6) then posvalue:=posvalue+30;
        if (position[kk,6]=6) then posvalue:=posvalue+20;
        if (position[kk,5]=6) then posvalue:=posvalue+10;
        if (position[kk,2]=-6) then posvalue:=posvalue-30;
        if (position[kk,3]=-6) then posvalue:=posvalue-20;
        if (position[kk,4]=-6) then posvalue:=posvalue-10;
      end;
      for kk:=2 to 7 do for ii:=2 to 7 do begin
        if (position[kk,ii]=6) then begin
          if (position[kk-1,ii]=6) or (position[kk-1,ii-1]=6) or
             (position[kk-1,ii+1]=6) then posvalue:=posvalue+14;
          if (position[kk+1,ii]=6) or (position[kk+1,ii-1]=6) or
             (position[kk+1,ii+1]=6) then posvalue:=posvalue+14;
        end
        else if (position[kk,ii]=-6) then begin
          if (position[kk-1,ii]=-6) or (position[kk-1,ii-1]=-6) or
             (position[kk-1,ii+1]=-6) then posvalue:=posvalue-14;
          if (position[kk+1,ii]=-6) or (position[kk+1,ii-1]=-6) or
             (position[kk+1,ii+1]=-6) then posvalue:=posvalue-14;
        end
      end;

  {kaikki posvalue-muutokset muut kuin materiaali}

  store:=posvalue;
  ii:=1;
  repeat
   if (legmvs[depth,ii].degree=3) then found:=true;
   ii:=ii+1;
  until ((found) or (ii>legals[depth]));
  if (found) then begin
  bestvalue:=posvalue;
  if ((forwhite) and (bestvalue>=beta[depth-1]))
    or ((not forwhite) and (bestvalue<=beta[depth-1])) then goto 123
  end;


  cutoff:=false;

  for iii:=1 to 2 do
  for kkk:=1 to legals[depth] do
  if (legmvs[depth,kkk].degree=iii) then BEGIN

    taken:=position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank2];
    moved:=position[legmvs[depth,kkk].file1,legmvs[depth,kkk].rank1];

    if (taken=-6) then posvalue:=posvalue+100+(bonus div depth) else
    if (taken=6) then posvalue:=posvalue-100+(bonus div depth) else
    if (taken=-3) then posvalue:=posvalue+500+(bonus div depth) else
    if (taken=3) then posvalue:=posvalue-500+(bonus div depth) else
    if (taken=-4) then posvalue:=posvalue+300+(bonus div depth) else
    if (taken=4) then posvalue:=posvalue-300+(bonus div depth) else
    if (taken=-5) then posvalue:=posvalue+300+(bonus div depth) else
    if (taken=5) then posvalue:=posvalue-300+(bonus div depth) else
    if (taken=-2) then posvalue:=posvalue+900+(bonus div depth) else
    if (taken=2) then posvalue:=posvalue-900+(bonus div depth);

    if ((moved=6) and (legmvs[depth,kkk].rank2=ranks))
       then posvalue:=posvalue+800;
    if ((moved=-6) and (legmvs[depth,kkk].rank2=1))
       then posvalue:=posvalue-800;
    if ((moved=6) and (legmvs[depth,kkk].file2<>legmvs[depth,kkk].file1)
    and (taken=0)) then begin
      position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank1]:=0;
      posvalue:=posvalue+100;
    end;
    if ((moved=-6) and (legmvs[depth,kkk].file2<>legmvs[depth,kkk].file1)
    and (taken=0)) then begin
      position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank1]:=0;
      posvalue:=posvalue-100;
    end;

    position[legmvs[depth,kkk].file1,legmvs[depth,kkk].rank1]:=0;
    position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank2]:=moved;
    if (moved=1) then begin
      wkx:=legmvs[depth,kkk].file2;wky:=legmvs[depth,kkk].rank2
    end;
    if (moved=-1) then begin
      bkx:=legmvs[depth,kkk].file2;bky:=legmvs[depth,kkk].rank2
    end;
    wq:=false;bq:=false;
    enpassant[depth+1]:=100;
    if ((moved=6) and (legmvs[depth,kkk].rank2=ranks)) then begin
    position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank2]:=2;
    wq:=true
    end;
    if ((moved=-6) and (legmvs[depth,kkk].rank2=1)) then begin
    position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank2]:=-2;
    bq:=true
    end;
    searchlegmvs(not forwhite,depth+1);


   if (legals[depth+1]=-2) then posvalue:=0
   else if (legals[depth+1]=-1) then begin
      if (forwhite) then posvalue:=10001-depth
      else posvalue:=depth-10001;
    end
  else BEGIN
    notsafesqr:=false;k:=1;
    repeat
    if (legmvs[depth+1,k].degree<3) then
      if ((legmvs[depth+1,k].file2=legmvs[depth,kkk].file2) and
      (legmvs[depth+1,k].rank2=legmvs[depth,kkk].rank2))
      then notsafesqr:=true;
      k:=k+1;
    until ((k>legals[depth+1]) or (notsafesqr));
    if notsafesqr then
    if (wq) then posvalue:=posvalue-900+(bonus div depth) else
    if (bq) then posvalue:=posvalue+900+(bonus div depth) else
    if (moved=2) then posvalue:=posvalue-900+(bonus div depth) else
    if (moved=3) then posvalue:=posvalue-500+(bonus div depth) else
    if (moved=4) then posvalue:=posvalue-300+(bonus div depth) else
    if (moved=5) then posvalue:=posvalue-300+(bonus div depth) else
    if (moved=6) then posvalue:=posvalue-100+(bonus div depth) else
    if (moved=-2) then posvalue:=posvalue+900+(bonus div depth) else
    if (moved=-3) then posvalue:=posvalue+500+(bonus div depth) else
    if (moved=-4) then posvalue:=posvalue+300+(bonus div depth) else
    if (moved=-5) then posvalue:=posvalue+300+(bonus div depth) else
    if (moved=-6) then posvalue:=posvalue+100+(bonus div depth);
    END;

    movevalue:=posvalue;
    position[legmvs[depth,kkk].file1,legmvs[depth,kkk].rank1]:=moved;
    position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank2]:=taken;
    if ((moved=6) and (legmvs[depth,kkk].file2<>legmvs[depth,kkk].file1)
    and (taken=0)) then begin
      position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank1]:=-6
    end;
    if ((moved=-6) and (legmvs[depth,kkk].file2<>legmvs[depth,kkk].file1)
    and (taken=0)) then begin
      position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank1]:=6
    end;
    if (moved=1) then begin
      wkx:=legmvs[depth,kkk].file1;wky:=legmvs[depth,kkk].rank1
    end;
    if (moved=-1) then begin
      bkx:=legmvs[depth,kkk].file1;bky:=legmvs[depth,kkk].rank1
    end;
    if (((not forwhite) and (movevalue<bestvalue))
    or ((forwhite) and (movevalue>bestvalue))) then begin
      bestvalue:=movevalue;
      if (depth=3) then b3:=legmvs[depth,kkk]
    end;


    if ((forwhite) and (bestvalue>=beta[depth-1])) then begin
    cutoff:=true;
      killer2[depth]:=killer[depth];
      killer[depth]:=legmvs[depth,kkk];
    end;
    if ((not forwhite) and (bestvalue<=beta[depth-1])) then begin
    cutoff:=true;
      killer2[depth]:=killer[depth];
      killer[depth]:=legmvs[depth,kkk];
    end;



    if (not analysis) then begin
    if ((forwhite) and (bestvalue>9000)) then cutoff:=true;
    if ((not forwhite) and (bestvalue<-9000)) then cutoff:=true;
    end;

    posvalue:=store;

    if ((cutoff) or (keskeyta)) then goto 123;
  END;
123: posvalue:=muisti;
evaluate:=bestvalue;
End;
{*************************************************************************}
Function minimax(forwhite:boolean;depth,plusd:integer):integer;
Var ii,jj,ij,store,k,iii,kkk,kk,movevalue,px,py,ppp,
    bestvalue,plusdm,nswap:integer;
    moved,taken:shortint;helpmv:movetype;
    wq,bq,olisama,cutoff,found,pois:boolean;
Begin

  if (depth>2) then beta[depth]:=beta[depth-2];
  if (legals[depth]=1) then plusd:=plusd+1 else
  if (isoin[depth]>17) then
  if (legals[depth]<=isoin[depth] div 6) then plusd:=plusd+1;


  nswap:=1;

   if (legals[depth]>1) then begin
    found:=false;
    kkk:=1;
    repeat
     kkk:=kkk+1;
     if ((legmvs[depth,kkk].file1=killer[depth].file1) and
     (legmvs[depth,kkk].file2=killer[depth].file2) and
     (legmvs[depth,kkk].rank1=killer[depth].rank1) and
     (legmvs[depth,kkk].rank2=killer[depth].rank2)) then begin
      found:=true;
      helpmv:=legmvs[depth,nswap];
      legmvs[depth,nswap]:=legmvs[depth,kkk];
      legmvs[depth,kkk]:=helpmv;
      legmvs[depth,nswap].degree:=1;
      nswap:=nswap+1
     end
    until ((found) or (kkk=legals[depth]));
    if (not found) then begin
    if (forwhite) then killval[depth]:=-30000
    else killval[depth]:=30000
    end
  end;
   if (legals[depth]>3) then begin
    found:=false;
    kkk:=2;
    repeat
     kkk:=kkk+1;
     if ((legmvs[depth,kkk].file1=killer2[depth].file1) and
     (legmvs[depth,kkk].file2=killer2[depth].file2) and
     (legmvs[depth,kkk].rank1=killer2[depth].rank1) and
     (legmvs[depth,kkk].rank2=killer2[depth].rank2)) then begin
      found:=true;
      helpmv:=legmvs[depth,nswap];
      legmvs[depth,nswap]:=legmvs[depth,kkk];
      legmvs[depth,kkk]:=helpmv;
            legmvs[depth,nswap].degree:=1;
      nswap:=nswap+1
     end
    until ((found) or (kkk=legals[depth]));
  end;


  cutoff:=false;
  store:=posvalue;

  if (forwhite) then bestvalue:=-30000 else
  bestvalue:=30000;


  III:=0;plusdm:=plusd;
  REPEAT
  iii:=iii+1;
  kkk:=0;
  repeat
    kkk:=kkk+1;
    if (legmvs[depth,kkk].degree=iii) then begin

    plusd:=plusdm;
    curr[depth]:=kkk; if (depth=2) then k3:=0;

    taken:=position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank2];
    moved:=position[legmvs[depth,kkk].file1,legmvs[depth,kkk].rank1];

    if (taken=-6) then posvalue:=posvalue+100+(bonus div depth) else
    if (taken=6) then posvalue:=posvalue-100+(bonus div depth) else
    if (taken=-3) then posvalue:=posvalue+500+(bonus div depth) else
    if (taken=3) then posvalue:=posvalue-500+(bonus div depth) else
    if (taken=-4) then posvalue:=posvalue+300+(bonus div depth) else
    if (taken=4) then posvalue:=posvalue-300+(bonus div depth) else
    if (taken=-5) then posvalue:=posvalue+300+(bonus div depth) else
    if (taken=5) then posvalue:=posvalue-300+(bonus div depth) else
    if (taken=-2) then posvalue:=posvalue+900+(bonus div depth) else
    if (taken=2) then posvalue:=posvalue-900+(bonus div depth);

    if ((moved=6) and (legmvs[depth,kkk].rank2=ranks))
       then begin
       posvalue:=posvalue+800+(bonus div depth);
       end;
    if ((moved=-6) and (legmvs[depth,kkk].rank2=1))
       then begin
       posvalue:=posvalue-800+(bonus div depth);
       end;
    if ((moved=6) and (legmvs[depth,kkk].file2<>legmvs[depth,kkk].file1)
    and (taken=0)) then begin
      position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank1]:=0;
      posvalue:=posvalue+100;
    end;
    if ((moved=-6) and (legmvs[depth,kkk].file2<>legmvs[depth,kkk].file1)
    and (taken=0)) then begin
      position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank1]:=0;
      posvalue:=posvalue-100;
    end;


    position[legmvs[depth,kkk].file1,legmvs[depth,kkk].rank1]:=0;
    position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank2]:=moved;


  if (moved=1) and (legmvs[depth,kkk].file2=wkx+2) then begin
    position[8,1]:=0;position[6,1]:=3;
  end;
  if (moved=1) and (legmvs[depth,kkk].file2=wkx-2) then begin
    position[1,1]:=0;position[4,1]:=3;
  end;
  if (moved=-1) and (legmvs[depth,kkk].file2=bkx+2) then begin
    position[8,8]:=0;position[6,8]:=-3;
  end;
  if (moved=-1) and (legmvs[depth,kkk].file2=bkx-2) then begin
    position[1,8]:=0;position[4,8]:=-3;
  end;
    if (moved=1) then begin
      wkx:=legmvs[depth,kkk].file2;wky:=legmvs[depth,kkk].rank2
    end;
    if (moved=-1) then begin
      bkx:=legmvs[depth,kkk].file2;bky:=legmvs[depth,kkk].rank2
    end;

    enpassant[depth+1]:=100;
    if ((moved=6) and (legmvs[depth,kkk].rank2-legmvs[depth,kkk].rank1=2))
      then enpassant[depth+1]:=legmvs[depth,kkk].file1;
    if ((moved=-6) and (legmvs[depth,kkk].rank1-legmvs[depth,kkk].rank2=2))
      then enpassant[depth+1]:=legmvs[depth,kkk].file1;
      wq:=false;bq:=false;
    if ((moved=6) and (legmvs[depth,kkk].rank2=ranks)) then begin
    position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank2]:=2;
    wq:=true;
    end;

    if ((moved=-6) and (legmvs[depth,kkk].rank2=1)) then begin
    position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank2]:=-2;
    bq:=true
    end;

    searchlegmvs(not forwhite,depth+1);
    if (depth=2) and (legals[3]>0) then begin
      for kk:=1 to legals[3] do
      if (legmvs[3,kk].degree<3) and (k3<26) then k3:=k3+4
    end;
    if (isoin[depth+1]>17) then ppp:=isoin[depth+1] div 6 else
    ppp:=1;
    if ((depth mod 2=1) and (legals[depth+1]<=ppp)) then begin
      found:=true;
      kk:=depth-1;
      repeat
         if (isoin[kk]>17) then ppp:=isoin[kk] div 6
         else ppp:=1;
         if (legals[kk]>ppp) then found:=false;
        kk:=kk-2;
      until ((kk<3) or (not found));
      if (found) then plusd:=plusd+1;
    end;


    if (legals[depth+1]=-2) then posvalue:=0;
    if (legals[depth+1]=-1) then begin
      if (forwhite) then posvalue:=10001-depth
      else posvalue:=depth-10001;
    end;

    if ((plusd=plusdm) and (depth mod 2=1) and (abs(moved)=1)
    and (plusd<2) and (legals[depth]<isoin[depth] div 2))
    then plusd:=plusd+1;

    if (searchdepth<4) then kk:=searchdepth+1
    else kk:=searchdepth+3;
    if (plusd>kk) then plusd:=kk;
    if (analysis) then plusd:=0;
    if (forwhite) then killval[depth+1]:=30000
    else killval[depth+1]:=-30000;

    thispos:='';
     if (depth<4) then for px:=1 to 8 do for py:=1 to 8 do
     thispos:=thispos+chr(position[px,py]+ord('K'));
     ppp:=1;olisama:=false;

     if (depth<4) then repeat
       if ((depth=3) and (oldpos[ppp]=thispos)) then olisama:=true;
       if ((depth=2) and (oldopp[ppp]=thispos)) then olisama:=true;
       ppp:=ppp+1
     until ((ppp>noldpos) or (olisama));

    if (olisama) then movevalue:=0
    else if ((legals[depth+1]<1) or (searchdepth=1)) then movevalue:=posvalue
    else if ((searchdepth+plusd<=depth) or (depth>maxdepth-3)) then begin
       movevalue:=evaluate(not forwhite,depth+1)
    end
    else
    movevalue:=minimax(not forwhite,depth+1,plusd);


    position[legmvs[depth,kkk].file1,legmvs[depth,kkk].rank1]:=moved;
    position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank2]:=taken;
    if ((moved=6) and (legmvs[depth,kkk].file2<>legmvs[depth,kkk].file1)
    and (taken=0)) then begin
      position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank1]:=-6
    end;
    if ((moved=-6) and (legmvs[depth,kkk].file2<>legmvs[depth,kkk].file1)
    and (taken=0)) then begin
      position[legmvs[depth,kkk].file2,legmvs[depth,kkk].rank1]:=6
    end;
    if (moved=1) then begin
      wkx:=legmvs[depth,kkk].file1;wky:=legmvs[depth,kkk].rank1
    end;
    if (moved=-1) then begin
      bkx:=legmvs[depth,kkk].file1;bky:=legmvs[depth,kkk].rank1
    end;
  if (moved=1) and (legmvs[depth,kkk].file2=wkx+2) then begin
    position[8,1]:=3;position[6,1]:=0;
  end;
  if (moved=1) and (legmvs[depth,kkk].file2=wkx-2) then begin
    position[1,1]:=3;position[4,1]:=0;
  end;
  if (moved=-1) and (legmvs[depth,kkk].file2=bkx+2) then begin
    position[8,8]:=-3;position[6,8]:=0;
  end;
  if (moved=-1) and (legmvs[depth,kkk].file2=bkx-2) then begin
    position[1,8]:=-3;position[4,8]:=0;
  end;
    if (((not forwhite) and (movevalue<bestvalue))
    or ((forwhite) and (movevalue>bestvalue))) then begin
      bestvalue:=movevalue;
      if (depth=3) then b3:=legmvs[depth,kkk];
      if (depth=2) then begin
      b2:=legmvs[depth,kkk];
      best3:=b3
      end
    end;


    if ((forwhite) and (bestvalue>=beta[depth-1])) then begin
      cutoff:=true;
      if (bestvalue>killval[depth]) then begin
      killer2[depth]:=killer[depth];
      killer[depth]:=legmvs[depth,kkk];
      killval[depth]:=bestvalue;
      end
    end;
    if ((not forwhite) and (bestvalue<=beta[depth-1])) then begin
      cutoff:=true;
      if (bestvalue<killval[depth]) then begin
       killer2[depth]:=killer[depth];
       killer[depth]:=legmvs[depth,kkk];
       killval[depth]:=bestvalue;
       end
    end;

    if ((forwhite) and (bestvalue>9000)) then begin
    if (not anaLYSIS) then cutoff:=true;
    end;

    if ((not forwhite) and (bestvalue<-9000)) then begin
    if (not anaLYSIS) then cutoff:=true;
    end;

     if ((forwhite) and (bestvalue>beta[depth]))
     then beta[depth]:=bestvalue;
     if ((not forwhite) and (bestvalue<beta[depth]))
     then beta[depth]:=bestvalue;


    posvalue:=store;


  END;
  until ((kkk=legals[depth]) or (cutoff) or (keskeyta));

  if (iii=2) and (depth mod 2=1) and (depth>3) and (wmat>1700)
  and (bmat>1700) and (depth>searchdepth+plusd-2) then pois:=true
  else pois:=false;

  UNTIL ((iii=3) or (keskeyta) or (pois) or (cutoff));

  if (depth=3) and (k3<26) then begin
    if ((forwhite) and (bestvalue>9000)) then k3:=k3+8;
    if ((not forwhite) and (bestvalue<-9000)) then k3:=k3+8;
     if ((forwhite) and (wmat>=bmat)
     and (bestvalue>wmat-bmat+236)) then k3:=k3+4;
    if ((not forwhite) and (wmat<=bmat)
     and (bestvalue<wmat-bmat-236)) then k3:=k3+4;
  end;
  minimax:=bestvalue;
End;

{*************************************************************************}

procedure calcmat;
var ii,jj:integer;
Begin
  wmat:=0;bmat:=0;
  for ii:=1 to ranks do for jj:=1 to files do
       if (position[jj,ii]=2) then wmat:=wmat+900
  else if (position[jj,ii]=3) then wmat:=wmat+500
  else if (position[jj,ii]=4) then wmat:=wmat+300
  else if (position[jj,ii]=5) then wmat:=wmat+300
  else if (position[jj,ii]=6) then begin
  wmat:=wmat+100;
  end

  else if (position[jj,ii]=-2) then bmat:=bmat+900
  else if (position[jj,ii]=-3) then bmat:=bmat+500
  else if (position[jj,ii]=-4) then bmat:=bmat+300
  else if (position[jj,ii]=-5) then bmat:=bmat+300
  else if (position[jj,ii]=1) then begin
    wkx:=jj;wky:=ii
  end
  else if (position[jj,ii]=-1) then begin
    bkx:=jj;bky:=ii
  end
  else if (position[jj,ii]=-6) then begin
    bmat:=bmat+100;
  end;
end;

{*************************************************************************}
PROCEDURE compute(forwhite:boolean;var bestmove:movetype;var score:integer;
          seconds:longint);
Var best,bscore,tmpsc,ii,jj,iii,k,jjj,kkk,fh,pena,plusd,b3v,viimenen,
    joku,jjh,px,py,ppp:integer;
    moved,taken:shortint;cm:char;
    helpmv:movetype;
    olisama,found,wq,bq,repetition:boolean;


Begin
  positions:=0;kpos:=0;bigs:=0;b3v:=b3val;musta:=(not forwhite);
  for ii:=1 to maxdepth+1 do isoin[ii]:=2;
  gettime(ho1,mi1,se1,hu1);
  sekunnit:=0;
  smax:=seconds;
  if (smax=0) then smax:=1;


    destr:='';

  calcmat;

  material:=wmat-bmat;bonus:=material div 29;
  if (wmat<1600) or (bmat<1600) or (smax<100) then begin
    if (forwhite) then ekstra:=10 else ekstra:=-10
  end;

  searchlegmvs(forwhite,1);
    if (legals[1]>1) then begin
      found:=false;
    kkk:=1;
    repeat
     kkk:=kkk+1;
     if ((legmvs[1,kkk].file1=nextmove.file1) and
     (legmvs[1,kkk].file2=nextmove.file2) and
     (legmvs[1,kkk].rank1=nextmove.rank1) and
     (legmvs[1,kkk].rank2=nextmove.rank2)) then begin
      found:=true;
      helpmv:=legmvs[1,1];
      legmvs[1,1]:=legmvs[1,kkk];
      legmvs[1,kkk]:=helpmv;
     end
    until ((found) or (kkk=legals[1]))
    end;

  str(legals[1],mstr);
  for ii:=1 to legals[1] do begin
  movescores[ii]:=0;
  end;

  stopcalc:=false;keskeyta:=false;fh:=0;
  killer[2]:=killer[4];killer2[2]:=killer2[4];
  searchdepth:=1;
  iii:=1;
    if (forwhite) then beta[1]:=-30000 else
    beta[1]:=30000;
    bscore:=beta[1];
  repeat
    mcount:=iii;
    curr[1]:=iii;

    if (abs(movescores[iii])<9000) then BEGIN
    posvalue:=material;
    taken:=position[legmvs[1,iii].file2,legmvs[1,iii].rank2];
    moved:=position[legmvs[1,iii].file1,legmvs[1,iii].rank1];
    k1:=0;
    if (moved=3) and (legmvs[1,iii].file1<5) and (legmvs[1,iii].rank1=1)
      then k1:=k1+3-5*abs(legmvs[1,iii].file2-4);
    if (moved=3) and (legmvs[1,iii].file1>4) and (legmvs[1,iii].rank1=1)
      then k1:=k1+3-5*abs(legmvs[1,iii].file2-5);
    if (moved=-3) and (legmvs[1,iii].file1<5) and (legmvs[1,iii].rank1=8)
      then k1:=k1-3+5*abs(legmvs[1,iii].file2-4);
    if (moved=-3) and (legmvs[1,iii].file1>4) and (legmvs[1,iii].rank1=8)
      then k1:=k1-3+5*abs(legmvs[1,iii].file2-5);

    if (musta) and (moved>-6) and (moved<>-3) then begin
    k1:=k1+(abs(wkx-legmvs[1,iii].file2)-abs(wkx-legmvs[1,iii].file1)
    +abs(wky-legmvs[1,iii].rank2)-abs(wky-legmvs[1,iii].rank1))
    end;
    if (not musta) and (moved<6) and (moved<>3) then begin
    k1:=k1-abs(bkx-legmvs[1,iii].file2)+abs(bkx-legmvs[1,iii].file1)
    -abs(bky-legmvs[1,iii].rank2)+abs(bky-legmvs[1,iii].rank1)
    end;
    if (musta) and (moved=-6) then k1:=k1-(movesmade div 15);
    if (not musta) and (moved=6) then k1:=k1+(movesmade div 15);


    if (taken=-6) then posvalue:=posvalue+100+bonus+ekstra else
    if (taken=6) then posvalue:=posvalue-100+bonus+ekstra else
    if (taken=-3) then posvalue:=posvalue+500+bonus+ekstra else
    if (taken=3) then posvalue:=posvalue-500+bonus+ekstra else
    if (taken=-4) then posvalue:=posvalue+300+bonus+ekstra else
    if (taken=4) then posvalue:=posvalue-300+bonus+ekstra else
    if (taken=-5) then posvalue:=posvalue+300+bonus+ekstra else
    if (taken=5) then posvalue:=posvalue-300+bonus+ekstra else
    if (taken=-2) then posvalue:=posvalue+900+bonus+ekstra else
    if (taken=2) then posvalue:=posvalue-900+bonus+ekstra;

     if ((moved=6) and (legmvs[1,iii].rank2=ranks)) then begin
       posvalue:=posvalue+800+bonus;
     end;
     if ((moved=-6) and (legmvs[1,iii].rank2=1)) then begin
       posvalue:=posvalue-800+bonus;
     end;
if ((moved=6) and (legmvs[1,iii].file2<>legmvs[1,iii].file1)
    and (taken=0)) then begin
      position[legmvs[1,iii].file2,legmvs[1,iii].rank1]:=0;
      posvalue:=posvalue+100
    end;
    if ((moved=-6) and (legmvs[1,iii].file2<>legmvs[1,iii].file1)
    and (taken=0)) then begin
      position[legmvs[1,iii].file2,legmvs[1,iii].rank1]:=0;
      posvalue:=posvalue-100
    end;
    position[legmvs[1,iii].file1,legmvs[1,iii].rank1]:=0;
    position[legmvs[1,iii].file2,legmvs[1,iii].rank2]:=moved;

  if (moved=1) and (legmvs[1,iii].file2=wkx+2) then begin
    position[8,1]:=0;position[6,1]:=3;
  end;
  if (moved=1) and (legmvs[1,iii].file2=wkx-2) then begin
    position[1,1]:=0;position[4,1]:=3;
  end;
  if (moved=-1) and (legmvs[1,iii].file2=bkx+2) then begin
    position[8,8]:=0;position[6,8]:=-3;
  end;
  if (moved=-1) and (legmvs[1,iii].file2=bkx-2) then begin
    position[1,8]:=0;position[4,8]:=-3;
  end;
    if (moved=1) then begin
      wkx:=legmvs[1,iii].file2;wky:=legmvs[1,iii].rank2
    end;
    if (moved=-1) then begin
      bkx:=legmvs[1,iii].file2;bky:=legmvs[1,iii].rank2
    end;

    enpassant[2]:=100;
    if ((moved=6) and (legmvs[1,iii].rank2-legmvs[1,iii].rank1=2))
      then enpassant[2]:=legmvs[1,iii].file1;
    if ((moved=-6) and (legmvs[1,iii].rank1-legmvs[1,iii].rank2=2))
      then enpassant[2]:=legmvs[1,iii].file1;
      wq:=false;bq:=false;
    if ((moved=6) and (legmvs[1,iii].rank2=ranks))
    then begin
    position[legmvs[1,iii].file2,legmvs[1,iii].rank2]:=2;
    wq:=true;
    end;
    if ((moved=-6) and (legmvs[1,iii].rank2=1))
    then begin
    position[legmvs[1,iii].file2,legmvs[1,iii].rank2]:=-2;
    bq:=true;
    end;


    searchlegmvs(not forwhite,2);

    if (legals[2]=-2) then posvalue:=0;
    if (legals[2]=-1) then begin
      if (forwhite) then posvalue:=10000
      else posvalue:=-10000;
    end;
    storesc:=movescores[iii];
    plusd:=0;

    if (legals[2]<1) then movescores[iii]:=posvalue
    else begin
        if (forwhite) then beta[2]:=30000
        else beta[2]:=-30000;
      thispos:='';
     for px:=1 to 8 do for py:=1 to 8 do
     thispos:=thispos+chr(position[px,py]+ord('K'));
     ppp:=1;olisama:=false;
     repeat
       if oldpos[ppp]=thispos then olisama:=true;
       ppp:=ppp+1
     until ((ppp>noldpos) or (olisama));
     if (forwhite) then killval[2]:=30000
    else killval[2]:=-30000;
    if (k1>30) then k1:=30;
    if (k1<-30) then k1:=-30;

     if (olisama) and (not analysis) then
      movescores[iii]:=0
     else movescores[iii]:=minimax(not forwhite,2,plusd);


      if (((forwhite) and (movescores[iii]>beta[1])) or
        ((not forwhite) and (movescores[iii]<beta[1]))) then begin
        fh:=fh+1;
      end;
    end;

    if (keskeyta) then begin
    if (iii=1) then movescores[iii]:=storesc
    else begin
    if (forwhite) then movescores[iii]:=movescores[1]-10
    else movescores[iii]:=movescores[1]+10
    end
    end
    else begin
    viimenen:=iii;
    if (((forwhite) and (movescores[iii]>bscore)) or
    ((not forwhite) and (movescores[iii]<bscore))) then begin
     bscore:=movescores[iii];nextmove:=best3;
     if (postaa) then begin
    templine:=' '+chr(legmvs[1,iii].file1+96)+
    chr(legmvs[1,iii].rank1+48)+
    chr(legmvs[1,iii].file2+96)+
    chr(legmvs[1,iii].rank2+48);
    if (searchdepth>1) and (not olisama) then
    templine:=templine+' '+chr(b2.file1+96)+
    chr(b2.rank1+48)+
    chr(b2.file2+96)+
    chr(b2.rank2+48);
    if (searchdepth>2) and (not olisama) then
    templine:=templine+' '+chr(best3.file1+96)+
    chr(best3.rank1+48)+
    chr(best3.file2+96)+
    chr(best3.rank2+48);
if (forwhite) then
send(format('%d %d %d %d %s', [searchdepth,bscore,sekunnit,kpos*100+positions,templine]))
else
send(format('%d %d %d %d %s', [searchdepth,-bscore,sekunnit,kpos*100+positions,templine]))
     end;
     if (searchdepth>1) then beta[1]:=bscore;
    end
    end;

    position[legmvs[1,iii].file1,legmvs[1,iii].rank1]:=moved;
    position[legmvs[1,iii].file2,legmvs[1,iii].rank2]:=taken;
    if ((moved=6) and (legmvs[1,iii].file2<>legmvs[1,iii].file1)
    and (taken=0)) then begin
      position[legmvs[1,iii].file2,legmvs[1,iii].rank1]:=-6
    end;
    if ((moved=-6) and (legmvs[1,iii].file2<>legmvs[1,iii].file1)
    and (taken=0)) then begin
      position[legmvs[1,iii].file2,legmvs[1,iii].rank1]:=6
    end;
    if (moved=1) then begin
      wkx:=legmvs[1,iii].file1;wky:=legmvs[1,iii].rank1
    end;
    if (moved=-1) then begin
      bkx:=legmvs[1,iii].file1;bky:=legmvs[1,iii].rank1
    end;
  if (moved=1) and (legmvs[1,iii].file2=wkx+2) then begin
    position[8,1]:=3;position[6,1]:=0;
  end;
  if (moved=1) and (legmvs[1,iii].file2=wkx-2) then begin
    position[1,1]:=3;position[4,1]:=0;
  end;
  if (moved=-1) and (legmvs[1,iii].file2=bkx+2) then begin
    position[8,8]:=-3;position[6,8]:=0;
  end;
  if (moved=-1) and (legmvs[1,iii].file2=bkx-2) then begin
    position[1,8]:=-3;position[4,8]:=0;
  end;

END;

    iii:=iii+1;

    if (iii>legals[1]) then begin

      joku:=legals[1]-1;

      if ((searchdepth>1) and (joku>fh)) then joku:=fh;
      if (joku>0) then
      for ii:=1 to joku do begin
       best:=ii+1;
        for jj:=ii+2 to legals[1] do begin
         if (((forwhite) and (movescores[jj]>movescores[best]))
         or ((not forwhite) and (movescores[jj]<movescores[best])))
         then best:=jj;
        end;

      if (((forwhite) and (movescores[best]>movescores[ii]))
       or ((not forwhite) and (movescores[best]<movescores[ii])))
      then begin
        tmpsc:=movescores[best];
        for jjh:=best downto ii+1 do movescores[jjh]:=movescores[jjh-1];
        movescores[ii]:=tmpsc;
        helpmv:=legmvs[1,best];
        for jjh:=best downto ii+1 do legmvs[1,jjh]:=legmvs[1,jjh-1];
        legmvs[1,ii]:=helpmv
      end
      end;


      searchdepth:=searchdepth+1;fh:=0;viimenen:=1;
      if ((not analysis) and (sekunnit>(smax*4) div 5)) then stopcalc:=true;

    if (forwhite) then beta[1]:=-30000 else
    beta[1]:=30000;
    bscore:=beta[1];

      if (searchdepth>maxdepth-2) then stopcalc:=true;
      if (abs(movescores[1])>9000) then begin
      stopcalc:=true;
      searchdepth:=searchdepth-1;
      end;
      iii:=1
    end;
    if (((forwhite) and (bscore>10000-searchdepth)) or
    ((not forwhite) and (bscore<-10000+searchdepth))) then stopcalc:=true;
    if (not analysis) then
    if (((forwhite) and (bscore>9000)) or
    ((not forwhite) and (bscore<-9000))) then stopcalc:=true;


    if (keskeyta) then stopcalc:=true;


  if ((legals[1]=1) and (searchdepth>2) and (not analysis))
  then stopcalc:=true;
  until (stopcalc);

  jjh:=viimenen;
  if ((iii=2) and (keskeyta)) then searchdepth:=searchdepth-1;

  best:=1;bscore:=movescores[1];
  if (jjh>1) then
  for iii:=2 to jjh do begin
    if (((forwhite) and (movescores[iii]>bscore))
    or ((not forwhite) and (movescores[iii]<bscore)))
       then begin
         bscore:=movescores[iii];
         best:=iii;
       end;
  end;

  bestmove:=legmvs[1,best];

  score:=movescores[best];
    gettime(ho2,mi2,se2,hu2);

      if (se2<se1) then se2:=se2+60;
      sekunnit:=sekunnit+100*se2-100*se1+hu2-hu1;

    if (postaa) then begin

   {  templine:=' '+chr(bestmove.file1+96)+chr(bestmove.rank1+48)+
    chr(bestmove.file2+96)+chr(bestmove.rank2+48);}
  if (not forwhite) then score:=-score;
send(format('%d %d %d %d %s', [searchdepth,score,sekunnit,kpos*100+positions,templine]));
     end;
End;

{*************************************************************************}
procedure set_initial_pos;
var i,j:integer;
begin
    forcing:=false;nerotime:=muisti;wmat:=500;bmat:=500;perakk:=0;
    for i:=1 to noldpos do oldpos[i]:='jotain';
        for i:=1 to noldpos do oldopp[i]:='jotain';
    for aa:=1 to blines do begin
      cee:=1+random(blines);
      templine:=bookline[aa]^;
      bookline[aa]^:=bookline[cee]^;
      bookline[cee]^:=templine
    end;
    avaus:='';

  for i:=1 to files do for j:=1 to ranks do position[i,j]:=0;
  position[1,2]:=6;position[2,2]:=6;position[3,2]:=6;position[4,2]:=6;
  position[5,2]:=6;position[6,2]:=6;position[7,2]:=6;position[8,2]:=6;
  position[1,1]:=3;position[2,1]:=5;position[3,1]:=4;position[4,1]:=2;
  position[5,1]:=1;position[6,1]:=4;position[7,1]:=5;position[8,1]:=3;
  position[1,7]:=-6;position[2,7]:=-6;position[3,7]:=-6;position[4,7]:=-6;
  position[5,7]:=-6;position[6,7]:=-6;position[7,7]:=-6;position[8,7]:=-6;
  position[1,8]:=-3;position[2,8]:=-5;position[3,8]:=-4;position[4,8]:=-2;
  position[5,8]:=-1;position[6,8]:=-4;position[7,8]:=-5;position[8,8]:=-3;
   whitesturn:=true;
   playeriswhite:=true;
   wkx:=5;wky:=1;bkx:=5;bky:=8;for i:=1 to maxdepth+1 do enpassant[i]:=100;
   mwk:=false;mbk:=false;mwra:=false;mbra:=false;mwrh:=false;mbrh:=false;
   movesmade:=0;lnopr:=0

end;

{*************************************************************************}
Procedure players_move;
var wasx,wasy,file1,rank1,file2,rank2,px,py,moved,taken,i,promoted:integer;
    escape,illegal:boolean;siirto:string;
Begin
  searchlegmvs(whitesturn,1);
  illegal:=true;
  file1:=ord(komento[1])+1-ord('a');
  rank1:=ord(komento[2])+1-ord('1');
  file2:=ord(komento[3])+1-ord('a');
  rank2:=ord(komento[4])+1-ord('1');
  promoted:=2;
  if (length(komento)=5) then begin
  if (komento[5] in ['q','Q']) then promoted:=2
  else if (komento[5] in ['r','R']) then promoted:=3
  else if (komento[5] in ['b','B']) then promoted:=4
  else if (komento[5] in ['n','N']) then promoted:=5
  end;
  for i:=1 to legals[1] do if ((legmvs[1,i].file1=file1) and
  (legmvs[1,i].file2=file2) and (legmvs[1,i].rank1=rank1) and
  (legmvs[1,i].rank2=rank2)) then illegal:=false;
  if (illegal) then begin
  send('Illegal move: '+komento)
  end
  else begin
    moved:=position[file1,rank1];
    taken:=position[file2,rank2];
    if ((abs(moved)=6) or (taken<>0)) then lnopr:=0
    else lnopr:=lnopr+1;
  if (moved=1) then begin
    mwk:=true;wkx:=file2;wky:=rank2;
    end;
  if (moved=-1) then begin
  mbk:=true;bkx:=file2;bky:=rank2;
  end;
  if ((file1=1) and (rank1=1)) then mwra:=true;
  if ((file1=8) and (rank1=1)) then mwrh:=true;
  if ((file1=1) and (rank1=8)) then mbra:=true;
  if ((file1=8) and (rank1=8)) then mbrh:=true;
  if ((file2=1) and (rank2=1)) then mwra:=true;
  if ((file2=8) and (rank2=1)) then mwrh:=true;
  if ((file2=1) and (rank2=8)) then mbra:=true;
  if ((file2=8) and (rank2=8)) then mbrh:=true;
  if (moved=1) and (file1+2=file2) then begin
    position[8,1]:=0;position[6,1]:=3;
  end;
  if (moved=1) and (file1-2=file2) then begin
    position[1,1]:=0;position[4,1]:=3;
  end;
  if (moved=-1) and (file1+2=file2) then begin
    position[8,8]:=0;position[6,8]:=-3;
  end;
  if (moved=-1) and (file1-2=file2) then begin
    position[1,8]:=0;position[4,8]:=-3;
  end;

    position[file1,rank1]:=0;
    position[file2,rank2]:=moved;
    if ((moved=6) and (rank2=ranks)) then
    position[file2,rank2]:=promoted;
    if ((moved=-6) and (rank2=1)) then
    position[file2,rank2]:=-promoted;
    enpassant[1]:=100;
    if ((moved=6) and (rank2-rank1=2)) then enpassant[1]:=file1;
    if ((moved=-6) and (rank1-rank2=2)) then enpassant[1]:=file1;
    if ((moved=6) and (file2<>file1) and (taken=0)) then begin
      position[file2,rank1]:=0;
    end;
    if ((moved=-6) and (file2<>file1) and (taken=0)) then begin
      position[file2,rank1]:=0;
    end;
    whitesturn:=(not whitesturn);
    movesmade:=movesmade+1;
      for i:=noldpos downto 2 do oldopp[i]:=oldopp[i-1];
    oldopp[1]:='';
     for px:=1 to 8 do for py:=1 to 8 do
     oldopp[1]:=oldopp[1]+chr(position[px,py]+ord('K'));

    if (length(avaus)<252) then avaus:=avaus+chr(file1+ord('a')-1)+chr(rank1+ord('0'))+
    chr(file2+ord('a')-1)+chr(rank2+ord('0'));
  end;
End;
{*************************************************************************}
procedure computers_move;
var mv:movetype;sc,px,py,moved,taken,i,j:integer;found:boolean;siirto,valim:string;
    fiu1,rau1,fiu2,rau2:integer;kevyt:boolean;
Begin

  found:=false;sc:=0;
  if (movesmade<16) then
  for i:=1 to blines do
  if ((length(bookline[i]^)>length(avaus)) and
  (copy(bookline[i]^,1,length(avaus))=avaus)) then begin
    found:=true;
    mv.file1:=ord(bookline[i]^[length(avaus)+1])+1-ord('a');
    mv.rank1:=ord(bookline[i]^[length(avaus)+2])+1-ord('1');
    mv.file2:=ord(bookline[i]^[length(avaus)+3])+1-ord('a');
    mv.rank2:=ord(bookline[i]^[length(avaus)+4])+1-ord('1');
  end;

  if (not found) then begin
    if (nerotime>0) then movesecs:=(nerotime div 31)+(5*(lisa) div 6);
    compute(whitesturn,mv,sc,movesecs);
    if (nerotime>0) then nerotime:=nerotime-sekunnit+lisa;
  end;

  moved:=position[mv.file1,mv.rank1];
  taken:=position[mv.file2,mv.rank2];
    if ((abs(moved)=6) or (taken<>0)) then lnopr:=0
    else lnopr:=lnopr+1;
  if (moved=1) then begin
  mwk:=true;wkx:=mv.file2;wky:=mv.rank2;
  end;
  if (moved=-1) then begin
  mbk:=true;bkx:=mv.file2;bky:=mv.rank2;
  end;
  if ((mv.file1=1) and (mv.rank1=1)) then mwra:=true;
  if ((mv.file1=8) and (mv.rank1=1)) then mwrh:=true;
  if ((mv.file1=1) and (mv.rank1=8)) then mbra:=true;
  if ((mv.file1=8) and (mv.rank1=8)) then mbrh:=true;
  if ((mv.file2=1) and (mv.rank2=1)) then mwra:=true;
  if ((mv.file2=8) and (mv.rank2=1)) then mwrh:=true;
  if ((mv.file2=1) and (mv.rank2=8)) then mbra:=true;
  if ((mv.file2=8) and (mv.rank2=8)) then mbrh:=true;
  position[mv.file1,mv.rank1]:=0;
  position[mv.file2,mv.rank2]:=moved;
  valim:='';
  if ((moved=6) and (mv.rank2=ranks)) then begin
  position[mv.file2,mv.rank2]:=2;
  valim:='q'
  end;
  if ((moved=-6) and (mv.rank2=1)) then begin
  position[mv.file2,mv.rank2]:=-2;
  valim:='q'
  end;
  enpassant[1]:=100;
  if ((moved=6) and (mv.rank2-mv.rank1=2)) then enpassant[1]:=mv.file1;
  if ((moved=-6) and (mv.rank1-mv.rank2=2)) then enpassant[1]:=mv.file1;
  if ((moved=6) and (mv.file2<>mv.file1) and (taken=0)) then begin
      position[mv.file2,mv.rank1]:=0;
    end;
    if ((moved=-6) and (mv.file2<>mv.file1) and (taken=0)) then begin
      position[mv.file2,mv.rank1]:=0;
    end;
    if (moved=1) and (mv.file1+2=mv.file2) then begin
    position[8,1]:=0;position[6,1]:=3;
  end;
  if (moved=1) and (mv.file1-2=mv.file2) then begin
    position[1,1]:=0;position[4,1]:=3;
  end;
  if (moved=-1) and (mv.file1+2=mv.file2) then begin
    position[8,8]:=0;position[6,8]:=-3;
  end;
  if (moved=-1) and (mv.file1-2=mv.file2) then begin
    position[1,8]:=0;position[4,8]:=-3;
  end;
  movesmade:=movesmade+1;

 whitesturn:=(not whitesturn);
  if (length(avaus)<252) then avaus:=avaus+chr(mv.file1+ord('a')-1)+chr(mv.rank1+ord('0'))+
  chr(mv.file2+ord('a')-1)+chr(mv.rank2+ord('0'));

    destr:=chr(mv.file1+96)+
    chr(mv.rank1+48)+
    chr(mv.file2+96)+
    chr(mv.rank2+48)+valim;


      if (sc<-880) then perakk:=perakk+1
      else perakk:=0;


    if (legals[1]=-2) then send('1/2-1/2 {Stalemate}')
    else if (legals[1]=-1) then begin
      if (playeriswhite) then send('1-0 {White mates}')
      else send('0-1 {Black mates}')
    end
    else if (perakk>4) and (lnopr<70) then begin
      if (playeriswhite) then send('1-0 {Black resigns}')
      else send('0-1 {White resigns}')
      end

    else send(concat('move ',destr));
      if (sc=10000) then
      if (playeriswhite) then send('0-1 {Black mates}')
      else send('1-0 {White mates}');
      calcmat;
      for i:=noldpos downto 2 do oldpos[i]:=oldpos[i-1];
    oldpos[1]:='';
     for px:=1 to 8 do for py:=1 to 8 do
     oldpos[1]:=oldpos[1]+chr(position[px,py]+ord('K'));
     px:=0;
     for i:=2 to noldpos do if (oldpos[i]=oldpos[1]) then px:=px+1;
     if (px>1) then send('1/2-1/2 {draw 3 rep.}') else
    if (lnopr>99) then send('1/2-1/2 {50 moves rule}') else
    if (wmat=0) and (bmat=0) then send('1/2-1/2 {material}') else
    if ((wmat=300) and (bmat=0) or (wmat=0) and (bmat=300)) then begin
    kevyt:=false;
    for i:=1 to 8 do for j:=1 to 8 do if (abs(position[i,j])=4) or
    (abs(position[i,j])=5) then kevyt:=true;
    if (kevyt) then send('1/2-1/2 {material}');
    end;

End;
{*************************************************************************}
BEGIN
  randomize;lstr:='0.0';


    for joku:=1 to blines do new(bookline[joku]);

  bookline[1]^:='e2e4g8f6e4e5f6d5d2d4d7d6c2c4d5b6e5d6c7d6g1f3g7g6f1e2f8g7e1g1e8g8';
  bookline[2]^:='e2e4g8f6e4e5f6d5d2d4d7d6c2c4d5b6f2f4d6e5f4e5b8c6c1e3c8f5b1c3e7e6';
  bookline[3]^:='e2e4g8f6e4e5f6d5d2d4d7d6g1f3g7g6f1c4d5b6c4b3f8g7f3g5e7e6d1f3d8e7';
  bookline[4]^:='e2e4g8f6e4e5f6d5c2c4d5b6c4c5b6d5f1c4e7e6b1c3d5c3d2c3b8c6c1f4f8c5';
  bookline[5]^:='e2e4e7e6d2d4d7d5c2c4d5e4b1c3g8f6c1e3b8c6g2g3f8b4f1g2e8g8g1e2e6e5';
  bookline[6]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1f8e7f1e1b7b5a4b3d7d6c2c3e8g8';
  bookline[7]^:='e2e4e7e5g1f3b8c6b1c3g8f6f1c4f8c5e1g1e8g8d2d3d7d6c3a4f6d7a4c5d7c5';
  bookline[8]^:='d2d4d7d5e2e4d5e4b1c3g8f6f2f3e4f3g1f3c8g4h2h3g4f3d1f3c7c6c1e3e7e6';
  bookline[9]^:='e2e4e7e5b1c3b8c6f1c4g8f6f2f4f6e4g1f3e4c3d2c3d8e7b2b4d7d6e1g1c8e6';
 bookline[10]^:='d2d4g8f6c2c4d7d6b1c3g7g6e2e4f8g7g1f3e8g8f1e2e7e5e1g1b8c6d4d5c6e7';
 bookline[11]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1f6e4d2d4b7b5a4b3d7d5d4e5c8e6';
 bookline[12]^:='e2e4e7e5g1f3b8c6f1c4g8f6d2d3f8e7b1c3d7d6';
 bookline[13]^:='c2c4c7c5b1c3b8c6g2g3g7g6f1g2f8g7g1f3e7e5e1g1g8e7d2d3e8g8a2a3d7d6';
 bookline[14]^:='e2e4c7c5g1f3d7d6d2d4c5d4f3d4g8f6b1c3a7a6f1e2e7e5d4b3f8e7e1g1c8e6';
 bookline[15]^:='e2e4d7d5e4d5d8d5b1c3d5a5d2d4g8f6g1f3c8g4h2h3g4f3d1f3c7c6c1d2b8d7';
 bookline[16]^:='e2e4g8f6e4e5f6d5g1f3d7d6d2d4g7g6e5d6c7d6c2c4d5b6h2h3f8g7f1e2e8g8';
 bookline[17]^:='f2f4d7d5g1f3g8f6e2e3g7g6f1e2f8g7e1g1e8g8';
 bookline[18]^:='d2d4g8f6c2c4c7c6b1c3d7d5e2e3g7g6g1f3f8g7f1d3e8g8e1g1c8g4h2h3g4f3';
 bookline[19]^:='g1f3e7e6g2g3g8f6f1g2b7b6e1g1c8b7d2d4f8e7c2c4e8g8b1c3f6e4d1c2e4c3';
 bookline[20]^:='e2e4e7e5g1f3b8c6f1c4g8f6b1c3f8c5e1g1d7d6d2d3';
 bookline[21]^:='e2e4e7e5g1f3b8c6f1c4g8f6b1c3f8c5d2d3d7d6c1e3c5e3f2e3c6a5c4b3e8g8';
 bookline[22]^:='e2e4e7e5g1f3b8c6f1c4g8f6b1c3f8c5d2d3d7d6c1g5h7h6g5f6d8f6c3d5f6d8';
 bookline[23]^:='e2e4d7d5e4d5g8f6f1b5c8d7b5c4b7b5c4b3';
 bookline[24]^:='e2e4g8f6b1c3e7e5g1f3f8b4f3e5e8g8f1e2f8e8e5d3b4c3d2c3f6e4e1g1d7d5';
 bookline[25]^:='e2e4c7c5d2d4c5d4g1f3b8c6f3d4g8f6b1c3d7d6f1e2e7e5d4f3h7h6e1g1f8e7';
 bookline[26]^:='c2c3c7c5g1f3d7d5d2d4c5d4c3d4g8f6c1f4c8f5e2e3b8c6f1b5a8c8f3e5f6d7';
 bookline[27]^:='c2c4e7e5b1c3g8f6g1f3b8c6e2e4f8b4d2d3e8g8g2g3d7d6f1g2a7a6c1d2';
 bookline[28]^:='e2e4c7c5d2d4c5d4g1f3b8c6f3d4g8f6b1c3d7d6f1e2e7e5d4f3f8e7c1g5c8e6';
 bookline[29]^:='d2d4e7e6e2e4d7d5b1d2d5e4d2e4b8d7g1f3f8e7f1d3g8f6e4f6e7f6d1e2e8g8';
 bookline[30]^:='e2e4c7c5d2d4c5d4g1f3b8c6f3d4g8f6b1c3d7d6f1e2e7e5d4b3f8e7e1g1e8g8';
 bookline[31]^:='e2e4c7c5d2d4c5d4g1f3b8c6f3d4g8f6b1c3d7d6c1g5e7e6d1d2f8e7e1c1e8g8';
 bookline[32]^:='f2f4d7d5e2e3g8f6b2b3e7e6g1f3c7c5c1b2f8e7f1b5c8d7';
 bookline[33]^:='f2f4d7d5g1f3g8f6e2e3c8g4h2h3g4f3d1f3b8c6';
 bookline[34]^:='e2e4c7c5d2d4c5d4g1f3b8c6f3d4g8f6b1c3d7d6f1c4e7e6c4b3f8e7c1e3e8g8';
 bookline[35]^:='e2e4e7e5g1f3b8c6f1b5d7d6d2d4c8d7b1c3g8f6e1g1f8e7f1e1e5d4f3d4e8g8';
 bookline[36]^:='e2e4e7e6d2d4d7d5b1c3g8f6c1g5f8e7e4e5f6d7g5e7d8e7f2f4c7c5g1f3b8c6';
 bookline[37]^:='e2e4e7e6d2d4d7d5b1c3f8b4e4e5c7c5a2a3b4c3b2c3g8e7g1f3b8c6f1e2d8a5';
 bookline[38]^:='e2e4c7c5g1f3e7e6d2d4c5d4f3d4a7a6b1c3b8c6c1e3g8f6f1d3d7d5e4d5e6d5';
 bookline[39]^:='d2d4d7d5c2c4e7e6b1c3g8f6c1g5b8d7e2e3c7c6g1f3d8a5f3d2d5c4g5f6d7f6';
 bookline[40]^:='d2d4d7d5c2c4e7e6b1c3g8f6c1g5f8e7e2e3e8g8g1f3b8d7a1c1c7c6f1d3d5c4';
 bookline[41]^:='d2d4g8f6c2c4g7g6b1c3f8g7g2g3e8g8f1g2d7d6g1f3b8d7e1g1e7e5e2e4c7c6';
 bookline[42]^:='d2d4d7d5g1f3c7c6c2c4e7e6e2e3g8f6b1c3b8d7f1d3d5c4d3c4b7b5c4d3c8b7';
 bookline[43]^:='g1f3g8f6g2g3b7b6f1g2c8b7e1g1c7c5d2d3e7e6e2e4d7d6b1c3f8e7';
 bookline[44]^:='d2d4g8f6c2c4e7e6b1c3d7d5g1f3f8e7c1f4e8g8e2e3c7c5d4c5e7c5d1c2b8c6';
 bookline[45]^:='d2d4g8f6c2c4e7e5d4e5f6g4c1f4b8c6g1f3f8b4b1d2d8e7a2a3g4e5f3e5c6e5';
 bookline[46]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4d7d6b1c3';
 bookline[47]^:='d2d4g8f6c2c4e7e6g1f3d7d5c1g5f8e7b1c3e8g8e2e3h7h6g5f6e7f6a1c1c7c6';
 bookline[48]^:='d2d4d7d5c2c4d5c4g1f3g8f6e2e3c8g4f1c4e7e6h2h3g4h5e1g1a7a6b1c3b8c6';
 bookline[49]^:='c2c4e7e5b1c3g8f6g1f3b8c6g2g3d7d5c4d5f6d5d2d3d5b6f1g2f8e7e1g1e8g8';
 bookline[50]^:='e2e4c7c6d2d4d7d5b1d2d5e4d2e4b8d7f1c4g8f6e4g3e7e6g1f3c6c5';
 bookline[51]^:='c2c4e7e5b1c3g8f6g1f3b8c6g2g3d7d5c4d5f6d5d2d3d5b6f1g2f8e7e1g1e8g8';
 bookline[52]^:='e2e4e7e5g1f3b8c6d2d4e5d4f3d4g8f6b1c3f8b4d4c6b7c6f1d3d7d5e4d5c6d5';
 bookline[53]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1f6e4d2d4b7b5a4b3d7d5d4e5c8e6';
 bookline[54]^:='e2e4c7c5d2d4c5d4c2c3d7d5';
 bookline[55]^:='d2d4d7d5c2c4e7e6b1c3c7c6g1f3d5c4a2a4f8b4e2e3b7b5c1d2c8b7a4b5b4c3';
 bookline[56]^:='d2d4g8f6c2c4e7e6g1f3b7b6a2a3c8b7b1c3d7d5c4d5f6d5d1c2d5c3b2c3f8e7';
 bookline[57]^:='d2d4g8f6c2c4e7e6g1f3b7b6g2g3c8b7f1g2f8e7e1g1e8g8b1c3f6e4d1c2e4c3';
 bookline[58]^:='e2e4c7c6d2d4d7d5e4e5c8f5g1e2e7e6h2h4h7h6e2g3f5g6h4h5g6h7f1d3h7d3';
 bookline[59]^:='e2e4e7e5f1c4g8f6d2d3c7c6g1f3d7d5c4b3f8d6b1c3d5e4d3e4b8a6c1e3d8e7';
 bookline[60]^:='d2d4g8f6c2c4g7g6b1c3f8g7e2e4d7d6g1f3e8g8f1e2e7e5e1g1b8c6d4d5c6e7';
 bookline[61]^:='g1f3d7d5c2c4c7c6d2d4e7e6e2e3g8f6b1c3b8d7a2a3f8d6f1d3e8g8e1g1d5c4';
 bookline[62]^:='d2d4d7d5g1f3g8f6c2c4c7c6b1c3e7e6e2e3b8d7f1d3d5c4d3c4b7b5c4d3c8b7';
 bookline[63]^:='e2e4e7e5g1f3g8f6f3e5d8e7d2d4d7d6e5f3e7e4f1e2c8f5c2c4d6d5b1c3f8b4';
 bookline[64]^:='g1f3e7e6g2g3g8f6f1g2b7b6e1g1c8b7d2d3d7d5b1d2b8d7c2c3f8e7d1c2e8g8';
 bookline[65]^:='e2e4e7e5f2f4e5f4g1f3d7d6f1c4c8e6c4e6f7e6d2d4d8f6d1d2';
 bookline[66]^:='e2e4d7d6d2d4g8f6b1c3g7g6f2f4f8g7g1f3c7c5f1b5b8c6d4c5d8a5e1g1e8g8';
 bookline[67]^:='e2e4c7c5g1f3e7e6d2d4c5d4f3d4b8c6d4b5d7d6c2c4g8f6b1c3a7a6b5a3f8e7';
 bookline[68]^:='e2e4c7c6d2d4d7d5b1d2d5e4d2e4g8f6e4g3b8d7g1f3e7e6f1d3c6c5e1g1c5d4';
 bookline[69]^:='e2e4e7e5g1f3b8c6f1c4g8f6f3g5d7d5e4d5c6a5c4b5c7c6d5c6';
 bookline[70]^:='e2e4c7c6g1f3d7d5b1c3c8g4h2h3g4f3d1f3g8f6d2d3e7e6f1e2b8d7';
 bookline[71]^:='d2d4d7d5c2c4c7c6g1f3g8f6b1c3e7e6e2e3f8d6f1d3b8d7e3e4d5e4c3e4f6e4';
 bookline[72]^:='d2d4d7d5c2c4c7c6g1f3g8f6b1c3d5c4a2a4c8f5e2e3e7e6f1c4f8b4e1g1b8d7';
 bookline[73]^:='e2e4e7e5g1f3b8c6f1b5f8b4c2c3b4a5e1g1g8e7b5c6e7c6b2b4a5b6b4b5c6a5';
 bookline[74]^:='d2d4g8f6c2c4c7c5d4d5b7b5c4b5a7a6b5a6c8a6b1c3d7d6g1f3g7g6e2e4a6f1';
 bookline[75]^:='e2e4e7e5g1f3g8f6f3e5d7d6e5f3f6e4d2d4d6d5f1d3b8c6e1g1f8e7c2c4c6b4';
 bookline[76]^:='e2e4c7c5d2d4c5d4c2c3e7e5';
 bookline[77]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5c6d7c6e1g1f7f6d2d4c8g4d4e5d8d1f1d1f6e5';
 bookline[78]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4d7d6c2c4';
 bookline[79]^:='e2e4e7e5g1f3b8c6f1b5g8f6';
 bookline[80]^:='e2e4c7c5d2d4c5d4c2c3d4c3b1c3b8c6g1f3e7e6f1c4d8c7d1e2g8f6h2h3d7d6';
 bookline[81]^:='g1f3d7d5g2g3c7c6f1g2c8g4e1g1g8f6c2c4e7e6b2b3b8d7c1b2f8d6d2d3e8g8';
 bookline[82]^:='d2d4g8f6c2c4g7g6b1c3f8g7e2e4d7d6g1f3e8g8f1e2e7e5e1g1b8c6d4d5c6e7';
 bookline[83]^:='d2d4g8f6c2c4c7c5d4d5e7e6b1c3e6d5c4d5d7d6e2e4g7g6g1f3f8g7f1e2e8g8';
 bookline[84]^:='e2e4e7e5f2f4f8c5g1f3b8c6';
 bookline[85]^:='e2e4e7e5f2f4e5f4b1c3d8h4e1e2d7d5c3d5c8g4g1f3f8d6d2d4b8c6c2c3g4f3';
 bookline[86]^:='d2d4d7d5c2c4e7e6b1c3g8f6c1g5f8e7e2e3e8g8a1c1b8d7g1f3c7c6f1d3d5c4';
 bookline[87]^:='d2d4d7d5c2c4c7c6c4d5c6d5g1f3b8c6b1c3g8f6c1f4c8f5e2e3e7e6f1b5f6d7';
 bookline[88]^:='d2d4g8f6c2c4e7e6g1f3d7d5b1c3d5c4e2e4f8b4c1g5c7c5e4e5c5d4f3d4d8a5';
 bookline[89]^:='d2d4d7d5c2c4c7c6g1f3g8f6b1c3d5c4a2a4b8a6e2e4c8g4f1c4e7e6c1e3a6b4';
 bookline[90]^:='e2e4c7c5c2c3g8f6e4e5f6d5d2d4c5d4c3d4d7d6g1f3b8c6f1c4e7e6e1g1f8e7';
 bookline[91]^:='e2e4c7c5g1f3d7d6d2d4c5d4f3d4g8f6b1c3a7a6f1e2e7e6e1g1f8e7f2f4e8g8';
 bookline[92]^:='g1f3d7d5g2g3c7c6f1g2g8f6e1g1c8g4h2h3g4f3g2f3e7e5d2d3b8d7b1d2f8c5';
 bookline[93]^:='d2d4c7c5d4c5e7e6b1c3f8c5c3e4g8f6e4c5d8a5c2c3a5c5g1f3d7d5';
 bookline[94]^:='e2e4c7c5g1f3e7e6d2d4c5d4f3d4b8c6';
 bookline[95]^:='c2c4g8f6b1c3c7c6e2e4d7d5e4d5c6d5d2d4e7e6c4d5f6d5g1f3f8b4c1d2e8g8';
 bookline[96]^:='e2e4e7e5b1c3g8f6f1c4f6e4d1h5e4d6h5e5d8e7e5e7f8e7c4b3d6f5g1f3c7c6';
 bookline[97]^:='d2d4d7d5c2c4e7e6b1c3g8f6c1g5f8e7e2e3e8g8a1c1b8d7g1f3c7c6f1d3d5c4';
 bookline[98]^:='e2e4e7e5b1c3g8f6g1f3f8b4f3e5e8g8f1e2f8e8e5d3b4c3d2c3f6e4e1g1d7d5';
 bookline[99]^:='e2e4c7c5b2b4c5b4a2a3d7d5e4d5d8d5g1f3e7e5c1b2b8c6c2c4d5e6f1d3f7f6';
bookline[100]^:='e2e4c7c5g1f3e7e6d2d4c5d4f3d4g8f6';
bookline[101]^:='e2e4c7c6b1c3d7d5d2d4d5e4c3e4b8d7g1f3g8f6e4g3e7e6f1d3c6c5e1g1c5d4';
bookline[102]^:='c2c4c7c6d2d4d7d5g1f3g8f6b1c3e7e6e2e3f8d6f1d3b8d7e3e4d5e4c3e4f6e4';
bookline[103]^:='e2e4c7c6b1c3d7d5g1f3c8g4h2h3g4f3d1f3e7e6d2d3g8f6f1e2b8d7';
bookline[104]^:='e2e4c7c6d2d4d7d5b1c3d5e4c3e4b8d7f1c4g8f6e4g5e7e6d1e2d7b6c4d3h7h6';
bookline[105]^:='e2e4c7c6b1c3d7d5d2d4d5e4c3e4b8d7f1c4g8f6e4g3e7e6g1f3c6c5';
bookline[106]^:='d2d4g8f6c2c4e7e6g1f3b7b6g2g3c8a6b2b3f8b4c1d2b4e7f1g2c7c6e1g1d7d5';
bookline[107]^:='e2e4c7c5c2c3d7d5e4d5d8d5d2d4e7e6g1f3g8f6b1a3b8c6f1e2d5d8a3c2c5d4';
bookline[108]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5c6d7c6e1g1f7f6d2d4e5d4f3d4c6c5d4b3d8d1';
bookline[109]^:='e2e4e7e6g1f3d7d5e4d5e6d5';
bookline[110]^:='d2d4g8f6c2c4c7c5d4d5b7b5c4b5a7a6b1c3a6b5e2e4d8a5c1d2b5b4e4e5b4c3';
bookline[111]^:='e2e4e7e5b1c3g8f6f2f4d7d5f4e5f6e4g1f3f8e7d2d4e8g8f1d3f7f5e5f6e7f6';
bookline[112]^:='e2e4e7e5g1f3g8f6f3e5d7d6e5f3f6e4d2d4d6d5f1d3f8d6e1g1e8g8c2c4c7c6';
bookline[113]^:='e2e4c7c6b1c3d7d5d2d4d5e4c3e4c8f5e4g3f5g6h2h4h7h6h4h5g6h7g1f3b8d7';
bookline[114]^:='e2e4c7c5c2c3d7d5e4d5d8d5d2d4e7e6g1f3b8c6f1e2g8f6b1a3d5d8a3c2f8e7';
bookline[115]^:='e2e4c7c6b1c3d7d5g1f3c8g4h2h3g4f3d1f3e7e6d2d3g8f6c1d2b8d7g2g4d5d4';
bookline[116]^:='e2e4e7e5g1f3b8c6d2d4e5d4c2c3d7d5e4d5d8d5c3d4f8b4b1c3c8g4f1e2g4f3';
bookline[117]^:='e2e4e7e5g1f3f7f5f3e5d8f6d2d4d7d6e5c4f5e4f1e2f6d8e1g1g8f6c1g5f8e7';
bookline[118]^:='e2e4e7e5g1f3b8c6d2d4e5d4c2c3d4c3b1c3f8b4f1c4d7d6d1b3b4c3b2c3d8d7';
bookline[119]^:='d2d4g8f6f2f3d7d5e2e4e7e6b1c3f8b4c1g5c7c5';
bookline[120]^:='f2f4e7e5e2e4e5f4g1f3d7d5e4d5g8f6f1b5c7c6d5c6b8c6d2d4f8d6e1g1e8g8';
bookline[121]^:='d2d4d7d5e2e4d5e4b1c3e7e5c1e3e5d4d1d4d8d4e3d4b8c6f1b5c8d7e1c1e8c8';
bookline[122]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1f6e4d2d4b7b5a4b3d7d5d4e5c8e6';
bookline[123]^:='e2e4e7e5g1f3b8c6f1c4g8f6d2d3f8e7e1g1e8g8c2c3d7d6c4b3h7h6';
bookline[124]^:='d2d4d7d5c2c4e7e6b1c3g8f6c1g5f8e7e2e3e8g8g1f3b8d7a1c1c7c6f1d3d5c4';
bookline[125]^:='g1f3c7c5c2c4g8f6b1c3b8c6d2d4c5d4f3d4e7e6d4b5d7d5c1f4e6e5c4d5e5f4';
bookline[126]^:='g1f3c7c5c2c4b7b6d2d4c5d4f3d4g8f6b1c3c8b7f2f3';
bookline[127]^:='c2c4c7c5b1c3g8f6g1f3e7e6g2g3b8c6f1g2f8e7e1g1d7d5c4d5f6d5c3d5e6d5';
bookline[128]^:='g1f3c7c5c2c4b8c6d2d4c5d4f3d4g7g6e2e4f8g7c1e3g8f6b1c3f6g4d1g4c6d4';
bookline[129]^:='g1f3c7c5c2c4g8f6b1c3b8c6d2d4c5d4f3d4g7g6g2g3';
bookline[130]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1f8e7f1e1b7b5a4b3d7d6c2c3e8g8';
bookline[131]^:='e2e4c7c5g1f3d7d6d2d4c5d4f3d4g8f6b1c3a7a6c1g5e7e6f2f4d8b6d4b3b8d7';
bookline[132]^:='e2e4c7c6g1f3d7d5e4d5c6d5f1b5c8d7';
bookline[133]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1f8e7a4c6d7c6d2d3f6d7b1d2e8g8';
bookline[134]^:='c2c4e7e5b1c3g8f6g1f3b8c6g2g3f8c5f1g2d7d6e1g1e8g8d2d3h7h6a2a3a7a6';
bookline[135]^:='e2e4c7c5g1f3d7d6b1c3e7e5f1c4b8c6';
bookline[136]^:='e2e4e7e5f2f4f8c5g1f3d7d6c2c3g8f6f4e5d6e5f3e5d8e7d2d4c5d6e5f3f6e4';
bookline[137]^:='e2e4e7e5f2f4f8c5d2d3b8c6';
bookline[138]^:='d2d4g8f6c2c4e7e6g1f3f8b4b1d2b7b6a2a3b4d2c1d2c8b7d2g5d7d6e2e3b8d7';
bookline[139]^:='d2d4g8f6c2c4e7e6g1f3f8b4c1d2d8e7g2g3b8c6f1g2b4d2b1d2d7d6e2e4e6e5';
bookline[140]^:='d2d4g8f6c2c4e7e6g1f3f8b4c1d2a7a5g2g3d7d5f1g2d5c4d1c2b8c6c2c4d8d5';
bookline[141]^:='d2d4g8f6c2c4e7e6g1f3c7c5d4d5b7b5d5e6f7e6c4b5d7d5e2e3f8d6b1c3c8b7';
bookline[142]^:='e2e4c7c5g1f3d7d6d2d4c5d4f3d4g8f6b1c3a7a6f1e2e7e5d4b3f8e7e1g1e8g8';
bookline[143]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1f8e7f1e1b7b5a4b3e8g8c2c3d7d6';
bookline[144]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1f8e7d1e2b7b5a4b3e8g8c2c3d7d5';
bookline[145]^:='f2f4d7d5g1f3g8f6e2e3g7g6b2b3f8g7c1b2e8g8f1e2c7c5e1g1b8c6f3e5c6e5';
bookline[146]^:='d2d4g8f6c2c4c7c5d4d5e7e6b1c3e6d5c4d5d7d6e2e4g7g6f2f4f8g7f1b5f6d7';
bookline[147]^:='d2d4g8f6c2c4c7c5d4d5e7e6b1c3e6d5c4d5d7d6g1f3g7g6e2e4f8g7f1e2e8g8';
bookline[148]^:='d2d4g8f6c2c4c7c5d4d5e7e6b1c3e6d5c4d5d7d6g1f3g7g6e2e4f8g7f1e2e8g8';
bookline[149]^:='e2e4e7e5g1f3b8c6f1c4c6d4e1g1';
bookline[150]^:='d2d4g8f6c2c4c7c5d4d5e7e6b1c3e6d5c4d5d7d6g1f3g7g6g2g3f8g7f1g2e8g8';
bookline[151]^:='e2e4c7c5c2c3e7e6d2d4d7d5e4e5c8d7g1f3d8b6a2a3c5c4b1d2b8c6f1e2c6a5';
bookline[152]^:='d2d4d7d6e2e4g7g6g1f3f8g7f1c4g8f6d1e2b8c6c2c3e8g8e1g1f6h5d4d5c6b8';
bookline[153]^:='c2c4c7c5b1c3b8c6g2g3g7g6f1g2f8g7g1f3e7e6e1g1g8e7d2d3e8g8c1f4d7d5';
bookline[154]^:='d2d4d7d5c2c4e7e6b1c3g8f6c1g5f8e7e2e3e8g8g1f3h7h6g5h4f6e4h4e7d8e7';
bookline[155]^:='d2d4d7d5c2c4e7e6b1c3g8f6g1f3f8b4c4d5e6d5c1g5b8d7e2e3c7c5f1d3c5c4';
bookline[156]^:='d2d4d7d5c2c4e7e6b1c3g8f6g1f3c7c5c4d5f6d5e2e3b8c6f1c4c5d4e3d4f8e7';
bookline[157]^:='d2d4d7d5c2c4e7e6b1c3g8f6c1g5f8e7e2e3e8g8g1f3h7h6g5h4b7b6c4d5f6d5';
bookline[158]^:='d2d4g8f6c2c4e7e6g1f3b7b6a2a3c7c5d4d5e6d5c4d5d7d6b1c3g7g6e2e4a7a6';
bookline[159]^:='d2d4g8f6c2c4e7e6g1f3b7b6a2a3c8b7b1c3d7d5c4d5f6d5e2e3f8e7f1b5c7c6';
bookline[160]^:='d2d4g8f6c2c4e7e6g1f3b7b6g2g3c8a6b2b3f8b4c1d2b4e7b1c3d7d5c4d5f6d5';
bookline[161]^:='d2d4g8f6c2c4e7e6g1f3b7b6e2e3c8b7f1d3f8e7b1c3d7d5e1g1e8g8b2b3c7c5';
bookline[162]^:='g1f3d7d5c2c4c7c6b2b3g8f6g2g3c8g4f1g2e7e6e1g1f8d6c1b2e8g8d2d3b8d7';
bookline[163]^:='e2e4g7g6d2d4f8g7b1c3d7d6f2f4c7c6g1f3c8g4c1e3d8b6d1d2g4f3g2f3b6b2';
bookline[164]^:='d2d4d7d5c2c4c7c6g1f3g8f6b1c3d5c4a2a4c8f5e2e3e7e6f1c4f8b4e1g1e8g8';
bookline[165]^:='d2d4d7d5c2c4c7c6c4d5c6d5b1c3g8f6c1f4b8c6e2e3c8f5g1f3e7e6f1b5f6d7';
bookline[166]^:='d2d4d7d5c2c4c7c6g1f3g8f6b1c3d5c4a2a4c8f5e2e3e7e6f1c4f8b4e1g1e8g8';
bookline[167]^:='d2d4d7d5c2c4c7c6g1f3g8f6b1c3e7e6e2e3b8d7f1d3d5c4d3c4b7b5c4d3a7a6';
bookline[168]^:='e2e4e7e5g1f3b8c6d2d4e5d4f3d4g7g6b1c3f8g7c1e3d7d6';
bookline[169]^:='e2e4c7c6d2d4d7d5e4e5c8f5g1e2e7e6e2g3f5g6h2h4h7h5f1d3g6d3d1d3d8a5';
bookline[170]^:='e2e4c7c5g1f3e7e6d2d4c5d4f3d4a7a6f1d3g8f6e1g1d7d6c2c4f8e7b1c3e8g8';
bookline[171]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1f8e7f1e1b7b5a4b3d7d6a2a4c6a5';
bookline[172]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1f8e7f1e1d7d6c2c3c8g4d2d3e8g8';
bookline[173]^:='e2e4e7e5b1c3g8f6f2f4d7d5f4e5f6e4g1f3f8e7d2d3e4c3b2c3e8g8c3c4f7f6';
bookline[174]^:='e2e4c7c5g1f3b8c6d2d4c5d4f3d4g8f6b1c3d7d6f1c4e7e6c4b3f8e7c1e3e8g8';
bookline[175]^:='e2e4c7c5d2d4c5d4c2c3d4c3b1c3b8c6g1f3d7d6f1c4e7e6e1g1g8f6d1e2f8e7';
bookline[176]^:='d2d4d7d5c2c4e7e6b1c3c7c5c4d5e6d5g1f3b8c6g2g3g8f6f1g2f8e7e1g1e8g8';
bookline[177]^:='e2e4e7e5g1f3b8c6b1c3f8c5f3e5c6e5d2d4c5d6d4e5d6e5c1d2g7g6f2f4e5g7';
bookline[178]^:='d2d4g8f6g1f3e7e6c1g5c7c5e2e3c5d4e3d4f8e7f1d3e8g8c2c3b7b6e1g1c8b7';
bookline[179]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1f6e4d2d4b7b5a4b3d7d5d4e5c8e6';
bookline[180]^:='e2e4b8c6d2d4d7d5b1c3e7e6e4e5';
bookline[181]^:='e2e4e7e5g1f3d7d6d2d4g8f6b1c3b8d7f1c4f8e7e1g1e8g8d1e2c7c6a2a4d8c7';
bookline[182]^:='c2c4c7c5g1f3g8f6d2d4c5d4f3d4e7e6b1c3f8b4d4b5d7d5c4d5e6d5a2a3b4c3';
bookline[183]^:='e2e4e7e5g1f3g8f6f3e5d7d6e5f3f6e4d2d4d6d5f1d3f8e7e1g1b8c6c2c4c6b4';
bookline[184]^:='c2c4c7c5b1c3b8c6g1f3g8f6d2d4c5d4f3d4e7e6d4b5d7d6c1f4e6e5f4g5a7a6';
bookline[185]^:='d2d4d7d5c2c4e7e6b1c3c7c5c4d5e6d5g1f3b8c6g2g3g8f6f1g2f8e7e1g1e8g8';
bookline[186]^:='d2d4d7d5c2c4d5c4g1f3g8f6e2e3e7e6f1c4c7c5e1g1a7a6d1e2b7b5c4b3c8b7';
bookline[187]^:='e2e4e7e5g1f3b8c6c2c3g8f6d2d4f6e4d4d5c6e7f3e5e7g6f1d3g6e5d3e4f8c5';
bookline[188]^:='e2e4d7d6d2d4g8f6b1c3g7g6g1f3f8g7f1e2e8g8e1g1c8g4c1e3b8c6d1d2e7e5';
bookline[189]^:='d2d4d7d5c2c4e7e6b1c3g8f6c4d5e6d5c1g5c7c6e2e3f8e7f1d3f6e4g5e7d8e7';
bookline[190]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1f8e7f1e1b7b5a4b3d7d6c2c3e8g8';
bookline[191]^:='e2e4d7d6d2d4g8f6b1c3g7g6f2f4f8g7g1f3e8g8f1d3b8c6e1g1c8g4e4e5d6e5';
bookline[192]^:='d2d4g8f6c2c4d7d6b1c3b8d7g1f3e7e5e2e4f8e7f1e2e8g8e1g1c7c6f1e1a7a6';
bookline[193]^:='e2e4e7e5g1f3g8f6f3e5d7d6e5f3f6e4d1e2d8e7d2d3e4f6';
bookline[194]^:='e2e4b8c6g1f3d7d6d2d4c8g4f1b5a7a6b5a4b7b5a4b3g8f6c2c3e7e6d1e2f8e7';
bookline[195]^:='d2d4g8f6c2c4e7e6b1c3f8b4a2a3b4c3b2c3e8g8f2f3f6e8e2e4b7b6f1d3c8a6';
bookline[196]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1f8e7f1e1b7b5a4b3d7d6c2c3c6a5';
bookline[197]^:='d2d4g8f6c2c4e7e6b1c3f8b4e2e3b7b6f1d3c8b7g1f3e8g8e1g1c7c5c3a4c5d4';
bookline[198]^:='d2d4g8f6c2c4e7e6b1c3f8b4e2e3e8g8f1d3d7d5g1f3c7c5e1g1b8c6a2a3b4c3';
bookline[199]^:='d2d4g8f6c2c4e7e6b1c3f8b4d1c2e8g8a2a3b4c3c2c3b7b6g1f3c8b7e2e3d7d6';
bookline[200]^:='d2d4g8f6c2c4e7e6b1c3f8b4e2e3e8g8g1f3d7d5f1d3c7c5e1g1d5c4d3c4b8d7';
bookline[201]^:='e2e4e7e5g1f3f7f5f3e5d8f6e5c4f5e4b1c3f6g6d2d3f8b4c1d2b4c3d2c3g8f6';
bookline[202]^:='d2d4g8f6c2c4g7g6b1c3f8g7e2e4d7d6f2f3e8g8c1e3b8c6g1e2a7a6d1d2a8b8';
bookline[203]^:='b2b3e7e5c1b2b8c6c2c4g8f6e2e3d7d5c4d5f6d5a2a3f8d6d1c2e8g8g1f3d8e7';
bookline[204]^:='d2d4g8f6c2c4g7g6b1c3f8g7e2e4d7d6f2f3e8g8c1e3e7e5d4d5f6h5d1d2f7f5';
bookline[205]^:='d2d4g8f6c2c4g7g6b1c3f8g7e2e4d7d6f2f4e8g8g1f3c7c5d4d5e7e6f1e2e6d5';
bookline[206]^:='d2d4g8f6c2c4g7g6b1c3f8g7e2e4d7d6g1f3e8g8f1e2e7e5e1g1b8c6d4d5c6e7';
bookline[207]^:='d2d4g8f6c2c4g7g6b1c3f8g7e2e4d7d6f1e2e8g8c1g5c7c5d4d5e7e6d1d2e6d5';
bookline[208]^:='d2d4g8f6c2c4g7g6b1c3f8g7e2e4d7d6g1f3e8g8f1e2e7e5e1g1b8c6d4d5c6e7';
bookline[209]^:='g1f3d7d5g2g3c7c5f1g2b8c6e1g1e7e5d2d3f8e7e2e4d5d4b1d2g8f6d2c4f6d7';
bookline[210]^:='e2e4e7e5f2f4d7d5e4d5e5e4d2d3g8f6b1c3f8b4c1d2e4e3d2e3e8g8e3d2b4c3';
bookline[211]^:='e2e4e7e5f2f4f8c5g1f3d7d6b1c3g8f6f1c4b8c6d2d3c8g4c3a4c5b6a4b6a7b6';
bookline[212]^:='e2e4e7e5g1f3g8f6b1c3b8c6';
bookline[213]^:='e2e4e7e5f2f4f8c5g1f3d7d5f3e5g8f6d2d4c5b6e4d5d8d5c1e3b8c6b1c3b6a5';
bookline[214]^:='d2d4g8f6c2c4g7g6g2g3f8g7f1g2d7d5c4d5f6d5g1f3e8g8e1g1d5b6b1c3b8c6';
bookline[215]^:='d2d4g8f6c2c4g7g6b1c3d7d5c1f4f8g7e2e3c7c5d4c5d8a5a1c1f6e4c4d5e4c3';
bookline[216]^:='d2d4g8f6c2c4g7g6b1c3d7d5c4d5f6d5e2e4d5c3b2c3f8g7g1f3c7c5a1b1e8g8';
bookline[217]^:='d2d4g8f6c2c4g7g6b1c3d7d5c4d5f6d5d1b3';
bookline[218]^:='d2d4g8f6c2c4g7g6b1c3d7d5c4d5f6d5e2e4d5c3b2c3f8g7f1c4e8g8g1e2c7c5';
bookline[219]^:='d2d4d7d5c2c4e7e6b1c3g8f6c1g5f8e7g1f3e8g8e2e3b8d7a1c1c7c6f1d3d5c4';
bookline[220]^:='e2e4g8f6b1c3e7e5f1c4b8c6g1f3f6e4c3e4d7d5c4d3d5e4d3e4f8d6d2d4e5d4';
bookline[221]^:='e2e4e7e5d1f3d8f6';
bookline[222]^:='e2e4e7e5g1f3b8c6f1c4f8c5c2c3g8f6d2d4e5d4c3d4c5b4c1d2b4d2b1d2d7d5';
bookline[223]^:='e2e4e7e5g1f3b8c6f1b5a7a6b5a4g8f6e1g1b7b5';
bookline[224]^:='d2d4f7f5c2c4g8f6g2g3d7d6f1g2c7c6';
bookline[225]^:='e2e4e7e6d2d4d7d5b1d2g8f6e4e5f6d7f1d3c7c5c2c3b8c6g1e2c5d4c3d4f7f6';
bookline[226]^:='e2e4e7e6d2d4d7d5b1d2c7c5e4d5e6d5g1f3b8c6f1b5f8d6d4c5d6c5e1g1g8e7';
bookline[227]^:='e2e4e7e6d2d4d7d5b1c3g8f6e4e5f6d7f2f4c7c5g1f3b8c6c1e3c5d4f3d4f8c5';
bookline[228]^:='e2e4e7e6d2d4d7d5b1c3d5e4c3e4b8d7g1f3g8f6e4f6d7f6f1d3c7c5d4c5f8c5';
bookline[229]^:='e2e4e7e6d2d4d7d5e4e5c7c5c2c3b8c6g1f3d8b6f1e2c5d4c3d4g8h6b1c3h6f5';
bookline[230]^:='e2e4e7e6d2d4d7d5e4e5c7c5c2c3b8c6g1f3d8b6a2a3c5c4g2g3c6a5b1d2c8d7';
bookline[231]^:='e2e4e7e5g1f3b8c6b1c3g8f6f1b5f8b4e1g1e8g8d2d3d7d6c1g5b4c3b2c3c8d7';
bookline[232]^:='c2c4c7c5b1c3b8c6g2g3g7g6f1g2f8g7e2e3e7e6g1e2g8e7e1g1e8g8d2d4c5d4';
bookline[233]^:='c2c4c7c5b1c3b8c6g1f3g8f6d2d4c5d4f3d4e7e6d4b5d7d5c1f4e6e5c4d5e5f4';
bookline[234]^:='c2c4e7e5b1c3b8c6g1f3g8f6g2g3f8b4f1g2e8g8e1g1e5e4f3g5b4c3b2c3f8e8';
bookline[235]^:='c2c4c7c5b1c3g8f6g2g3d7d5c4d5f6d5f1g2d5c7g1f3b8c6d1a4d8d7e1g1g7g6';
bookline[236]^:='d2d4f7f5c2c4g8f6g2g3e7e6f1g2d7d5g1f3c7c6e1g1f8d6b2b3d8e7c1b2e8g8';
bookline[237]^:='d2d4f7f5c2c4g8f6g2g3g7g6f1g2f8g7g1f3e8g8e1g1d7d6b1c3b8c6d4d5c6e5';
bookline[238]^:='d2d4f7f5c2c4g8f6g2g3e7e6f1g2f8e7g1f3e8g8e1g1d7d6b1c3d8e8d1c2e8h5';
bookline[239]^:='e2e4e7e5d2d4e5d4c2c3d7d5e4d5d8d5c3d4g8f6g1f3f8b4b1c3e8g8f1e2f6e4';
bookline[240]^:='e2e4c7c5g1f3b8c6f1c4d7d6e1g1g8f6f3g5e7e6';
bookline[241]^:='e2e4c7c5d1f3g8f6';
bookline[242]^:='d2d4g8f6c2c4c7c5d4d5e7e5b1c3d7d6e2e4f8e7g1f3e8g8h2h3b8d7g2g4a7a6';
bookline[243]^:='d2d4d7d5c2c4b8c6g1f3c8g4c4d5g4f3g2f3d8d5e2e3e7e6b1c3f8b4c1d2d5h5';
bookline[244]^:='d2d4d7d5g1f3g8f6e2e3e7e6f1d3c7c5c2c3b8c6b1d2f8d6e1g1e8g8f1e1e6e5';
bookline[245]^:='e2e4e7e5d2d4e5d4d1d4b8c6d4e3g8f6b1c3f8b4c1d2e8g8e1c1f8e8f1c4c6a5';
bookline[246]^:='e2e4d7d5e4d5g8f6d2d4f6d5c2c4d5b6g1f3g7g6f1e2f8g7e1g1e8g8b1c3';
bookline[247]^:='e2e4c7c6d2d4d7d5e4d5c6d5c2c4b8c6c4d5d8d5g1f3e7e5b1c3f8b4c1d2b4c3';
bookline[248]^:='e2e4d7d5e4d5d8d5b1c3d5a5d2d4g8f6g1f3c8g4h2h3g4h5g2g4h5g6f3e5e7e6';
bookline[249]^:='d2d4g8f6c2c4e7e6g2g3d7d5f1g2f8e7g1f3e8g8e1g1b8d7d1c2c7c6b1d2b7b6';
bookline[250]^:='d2d4g8f6c2c4e7e6g2g3d7d5f1g2d5c4g1f3f8e7e1g1e8g8d1c2a7a6c2c4b7b5';


  movesecs:=100;fixeddepth:=maxdepth;muisti:=0;postaa:=false;
  rrate:=4;    set_initial_pos;analysis:=false;

  repeat
      if (not forcing) then
      if (whitesturn=(not playeriswhite)) then computers_move;
      readln(komento);
      {$ifdef CREATELOG}
      log.append(concat('-> "', komento, '"'));
      {$endif}
      if (komento='quit') then
 else if (komento='new') then set_initial_pos
 else if (komento='random') then
 else if (komento='force') then forcing:=true
 else if (komento='xboard') then
 else if (komento='protover 2') then begin send('feature done=0 analyze=0 debug=1 myname="Nero 6.0" ping=1 sigint=0 sigterm=0'); send('feature done=1'); end
 else if (komento='hint') then
 else if (komento='hard') then
 else if (komento='easy') then
 else if (komento='post') then postaa:=true
 else if (komento='nopost') then postaa:=false
 else if (komento='go') then begin
   forcing:=false;
   playeriswhite:=(not whitesturn);
 end
 else if (komento='white') then begin
   whitesturn:=true;
   playeriswhite:=true;
 end
 else if (komento='black') then begin
   whitesturn:=false;
   playeriswhite:=false;
 end
 else if (copy(komento,1,4)='resu') then
  else if (copy(komento,1,3)='sd ') then begin
   komento[1]:=' ';komento[2]:=' ';val(komento,fixeddepth,aa)
  end
 else if (copy(komento,1,3)='st ') then begin
   komento[1]:=' ';komento[2]:=' ';val(komento,movesecs,aa);
   movesecs:=movesecs*100-5
  end
 else if (copy(komento,1,5)='level') then begin
   aa:=7;templine:='';
   repeat
   templine:=templine+komento[aa];
   aa:=aa+1;
   until (komento[aa]=' ');
   val(templine,siirrot,cee);
   templine:='';aa:=aa+1;
   repeat
     if (komento[aa]<>':') then templine:=templine+komento[aa];
     if (komento[aa]=':') then repeat
     aa:=aa+1
     until (komento[aa]=' ')
     else aa:=aa+1;
   until (komento[aa]=' ');
   val(templine,aika,cee);
   aika:=aika*6000;
   for cee:=1 to aa do komento[cee]:=' ';
   val(komento,lisa,cee);
   lisa:=lisa*100;
   if (siirrot>0) then begin
   movesecs:=aika div siirrot;
   movesecs:=movesecs-(movesecs div 20);
   end;
   nerotime:=0;
   if (siirrot=0) then nerotime:=aika;
   muisti:=nerotime;
  end
 else if (copy(komento,1,8)='accepted') then
 else if (copy(komento,1,4)='time') then
 else if (copy(komento,1,4)='otim') then
 else if (copy(komento,1,4)='ping') then
   send(format('pong %s',[copy(komento,6,length(komento)-5)]))
 
 else players_move;

  until (komento='quit');
  for joku:=1 to blines do dispose(bookline[joku]);
END.
